# generate water demands monthly - from NEST script demands.r
require(tidyverse)
require(ncdf4)
require(rgdal)
require(raster)
require(rgeos)
require(ggmap)
require(rasterVis)
require(countrycode)
memory.limit(size=1e9)

ssps= c( 'SSP1', 'SSP2', 'SSP3', 'SSP4', 'SSP5' )
n_days = c(31,28,31,30,31,30,31,31,30,31,30,31)

msg_data = paste0('P:/ene.model/NEST')
data_path = path.expand(msg_data)

crs = "+proj=longlat +datum=WGS84 +no_defs"

# ssp, we can also run 1 and 5, but need to retreive the data from older work
ssp = c(2)

# Grab the basin boundaries
reg = 'ZMB'
basin.spdf = readOGR('P:/ene.model/NEST/delineation/data/delineated_basins_new',
                               paste0('basins_by_region_simpl_',reg), verbose=FALSE)
basin.spdf2 = readOGR( paste( getwd(), 'input', sep = '/' ), 'Indus_bcu', verbose = FALSE )

basin.spdf = spTransform(basin.spdf, CRS("+proj=longlat"))
basin.spdf@data$PID = as.character( basin.spdf@data$BCU_name )
basin.spdf@data$CNTRY_ID = unlist( strsplit( basin.spdf@data$PID, '_' ) )[ seq(1,2*length(basin.spdf),by=2) ]
basin.sp = gUnaryUnion( basin.spdf )
basin.sp = SpatialPolygons(list(Polygons(Filter(function(f){f@ringDir==1},basin.sp@polygons[[1]]@Polygons),ID=1)))
buff.sp = gBuffer( basin.sp, width = 0.1 ) 
buff2.sp = gBuffer( basin.sp, width = 10 ) 
proj4string(basin.sp) = proj4string(basin.spdf)
proj4string(buff.sp) = proj4string(basin.spdf)
proj4string(buff2.sp) = proj4string(basin.spdf)

### Water demands from gridded indicators - using harmonized spatial datasets from Parkinson et al. 2016 A spatially explicit ...	
# Simulation horizon
yy = c(2015,seq(2020,2060,by=10))

# import national manufacturing demand projections 
national_manufacturing_withdrawal.df = data.frame(read.csv(paste0(data_path,"/manufacturing_water_demand_results/national/IIASA_water_withdrawal_manufacturing_Static.csv"), header=TRUE, sep=",", stringsAsFactors=F, as.is=T))
national_manufacturing_return.df = data.frame(read.csv(paste0(data_path,"/manufacturing_water_demand_results/national/IIASA_water_return_manufacturing_Static.csv"), header=TRUE, sep=",", stringsAsFactors=F, as.is=T))

# National GDP projections for scaling the manufacturing demands
national_gdp.df = data.frame(read.csv(paste0(data_path,"/GDP/OECD_SSP_GDP_PPP.csv"), header=TRUE, sep=",", stringsAsFactors=F, as.is=T)) %>% # in billions
  filter( Region %in% c(reg) ) %>%
  dplyr::select( Scenario, Region, paste('X',seq(2015,2060,by=5),sep='') )

# hours in each month
hr = c(31,28.25,31,30,31,30,31,31,30,31,30,31) * 24 

# go through each ssp and year and create flat dataframe containing the demand parameters
demands.df = bind_rows( lapply( ssp, function(ss){ 
  
  bind_rows( lapply( 1:length(yy), function(y){
    
    # haven't generated the data for each SSP - this is the mapping to the RCPs - could be updated to reflect different RCPs
    if(ss %in% c( 1,3,4 )){rr=1}
    if(ss==2){ rr=2 }
    if(ss==5){ rr=4 }
    
    # 2015 not included in the data so using 2010
    if( yy[y]==2015 ){ yy2=2010 }else{ yy2=yy[y] }
    
    # import the harmonzied gridded data and rename to make generic headings, add PID by overlaying the polygons, and then sum to PID-level
    dat.df = data.frame( readRDS( paste0(data_path,'/harmonized_rcp_ssp_data/water_use_ssp',ss,'_rcp',rr,'_',yy2,'_data.Rda') ) )
    cols = c( 'xloc', 'yloc', 'urban_pop', 'rural_pop', 'urban_gdp', 'rural_gdp', 'mean_tas', 'urban_withdrawal', 'rural_withdrawal', 'urban_return', 'rural_return' )
    for( nm in cols ){ 
      ind = which( grepl( nm, names( dat.df ) ) )
      if( length( ind ) > 1 ){ nm2 = paste( nm, 1:12,sep='.' )}else{ nm2 = nm }
      names(dat.df)[ ind ] = nm2 }
    dat.df = dat.df[,grepl( paste(cols,collapse='|'), names(dat.df) ) ]
    dat.df = dat.df %>%
      'coordinates<-'(~xloc+yloc) %>%
      'gridded<-'(TRUE) %>%
      'proj4string<-'( proj4string(basin.spdf) )
    dat.df$PID = unlist( over( dat.df, basin.spdf[,which(names(basin.spdf) == 'PID')] ) )
    dat.df = data.frame( dat.df ) %>% filter( !is.na( PID ) ) %>% dplyr::select( -xloc, -yloc ) 
    
    # elec.df = bind_rows( lapply( 1:12, function( mm ){
    #   left_join( 	dat.df %>% dplyr::select( PID, paste( 'mean_tas', mm, sep = '.' ) ),
    #               dat.df %>% dplyr::select( PID, urban_pop, rural_pop )  ) %>%
    #     dplyr::rename(tas = paste( 'mean_tas', mm, sep = '.' ) ) %>%
    #     group_by( PID ) %>%
    #     summarise( 	turb = abs( -18 -273 + sum( tas * urban_pop ) / sum( urban_pop ) ), 	# population weighted temperature
    #                 trur = abs( -18 -273 + sum( tas * rural_pop ) / sum( rural_pop ) ) ) %>%
    #     as.data.frame( ) %>% 
    #     mutate( turb = ifelse( is.nan( turb ), 0, turb ), trur = ifelse( is.nan( trur ), 0, trur ) ) %>%
    #     mutate( time = mm ) %>%
    #     dplyr::select( PID, time, turb, trur ) } ) ) %>%
    #   left_join( ., data.frame( time = 1:12, hr = hr ) ) %>% # add the hours in each month
    #   group_by( PID ) %>%
    #   mutate( turb =  0.4 * turb / sum( turb ) + 0.6 * hr / 8760, # downscaling factor assuming part of load insensitive to temperature
    #           trur =  0.4 * trur / sum( trur ) + 0.6 * hr / 8760 ) %>%	
    #   as.data.frame( ) %>%
    #   mutate( turb = ifelse( is.nan( turb ), 0, turb ), trur = ifelse( is.nan( trur ), 0, trur ) ) %>%		
    #   left_join( 	., dat.df %>% # adding gdp and pop for projecting demands based on intensities above
    #                 dplyr::select( PID, urban_gdp, urban_pop, rural_gdp, rural_pop ) %>%
    #                 group_by( PID ) %>% summarise_each( funs( sum ) ) %>% # summarise by PID
    #                 as.data.frame( ) %>%
    #                 mutate( urban_inc = urban_gdp / urban_pop, rural_inc = rural_gdp / rural_pop )	%>% # don't actually use the per capita income buts it's there in case used as alternative indicator
    #                 mutate( urban_inc = ifelse( is.nan( urban_inc ), 0, round( urban_inc ) ), 
    #                         rural_inc = ifelse( is.nan( rural_inc ), 0, round( rural_inc ) ) ) ) %>%
    #   left_join( ., data.frame( PID =  basin.spdf@data$PID, country = unlist( strsplit( basin.spdf@data$PID, '_' ) )[ seq( 1, 2*length(basin.spdf@data$PID), by=2 ) ] ) ) %>%	# add countries	
    #   left_join( . ,	as.data.frame( national.list )[ paste0( 'SSP', ss ),  ] %>% 
    #                gather( parameter, value ) %>% # flatten
    #                mutate( country = unlist( strsplit( parameter, '[.]' ) )[ seq( 1, 4*length( parameter ), by = 4 ) ],
    #                        var = unlist( strsplit( parameter, '[.]' ) )[ seq( 2, 4*length( parameter ), by = 4 ) ],
    #                        year = unlist( strsplit( parameter, '[.]' ) )[ seq( 4, 4*length( parameter ), by = 4 ) ] ) %>%
    #                filter( year == yy[y] ) %>% dplyr::select( country, var, value ) %>%
    #                spread( var, value ) ) %>%
    #   group_by( PID, time ) %>% # now project the demands using the gdp - might also instead use the per capita demand model
    #   summarise( 	urban_municipal_mw = round( 1e-6 * urban_gdp * ( national_residential_kwh_per_usd + national_commercial_kwh_per_usd ) * turb / hr / 1e-3 ),
    #               rural_municipal_mw = round( 1e-6 * rural_gdp * ( national_residential_kwh_per_usd + national_commercial_kwh_per_usd ) * trur / hr / 1e-3 ),
    #               industry_mw = round( 1e-6 * ( urban_gdp + rural_gdp ) * national_industry_kwh_per_usd / 8760 / 1e-3 ) ) %>%
    #   as.data.frame( ) %>% mutate( year = yy[y], scenario = paste0( 'SSP', ss ) ) %>%
    #   dplyr::select( scenario, PID, year, time, urban_municipal_mw, rural_municipal_mw, industry_mw )	%>%
    #   gather( type, value, urban_municipal_mw, rural_municipal_mw, industry_mw ) %>% 
    #   mutate( units = 'MW',  
    #           type = ifelse( grepl( 'urban', type ), 'urban_final', ifelse( grepl( 'rural', type ), 'rural_final', 'industry_final' ) ) ) %>%
    #   dplyr::select( scenario, PID, type, year, time, value )		
    
    # format for water demands
    dat.df = dat.df[ , ! grepl('mean_tas',names( dat.df )) ] # remove temperature
    dat.df = dat.df %>% group_by( PID ) %>% 
      summarise_each( funs( sum ) ) %>%
      as.data.frame( ) %>%
      mutate( urban_inc = urban_gdp / urban_pop, rural_inc = rural_gdp / rural_pop )	%>%
      mutate( urban_inc = ifelse( is.nan( urban_inc ), 0, round( urban_inc ) ), rural_inc = ifelse( is.nan( rural_inc ), 0, round( rural_inc ) ) )
    
    # Add manufactruring demands
    mf.df = rbind( 
      national_manufacturing_withdrawal.df %>% 
        filter( Country_Code %in% reg ) %>%
        filter( Scenario == paste0( 'SSP', ss ) ) %>%
        dplyr::rename( scenario = Scenario, country = Country_Code ) %>%
        mutate( type = 'withdrawal' ) %>%
        dplyr::select( scenario, country, type, paste0( 'X', yy2  ) ),
      national_manufacturing_return.df %>% 
        filter( Country_Code %in% reg ) %>%
        filter( Scenario == paste0( 'SSP', ss ) ) %>%
        dplyr::rename( scenario = Scenario, country = Country_Code ) %>%
        mutate( type = 'return' ) %>%
        dplyr::select( scenario, country, type, paste0( 'X', yy2  ) ) ) 
    names( mf.df )[ ncol( mf.df ) ] = 'value'
    mf.df$value = round( mf.df$value / 365.25, digits = 2 ) # convert to mcm_per_day
    mf.df = mf.df %>% spread( type, value )
    
    # national gdp for scaling mf demands
    gdp.df = national_gdp.df %>% 
      dplyr::rename( scenario = Scenario, country = Region ) %>% 
      filter(grepl(paste0("SSP",ssp),scenario)) %>% 
      mutate( scenario = unlist( strsplit( scenario, '_' ) )[1] ) %>%
      dplyr::select( scenario, country, paste0( 'X', yy[y]  ) )
    names( gdp.df )[ ncol( gdp.df ) ] = 'gdp_national'	
    
    # now scale
    dat.df = dat.df %>% 
      mutate( country = reg) %>%
      left_join( ., left_join( mf.df, gdp.df ), by = c( 'country' ) ) %>%
      mutate( manufacturing_withdrawal = round( withdrawal * ( urban_gdp + rural_gdp ) / ( 1e9 * gdp_national ), digits = 3 ) )  %>%
      mutate( manufacturing_return = round( return * ( urban_gdp + rural_gdp ) / ( 1e9 * gdp_national ), digits = 3 ) ) %>%
      dplyr::select(  -urban_pop, -urban_gdp, -rural_pop, -rural_gdp, -urban_inc, -rural_inc, -country, -scenario, -return, -withdrawal, -gdp_national )
    
    
    # expand manufacturing withdrawals and retunr flows to months - assuming constant instensity across the year
    mfw = bind_cols( lapply( 1:12, function( mmm ){ dat.df$manufacturing_withdrawal } ) )	%>% as.data.frame() %>% 'names<-'(paste('manufacturing_withdrawal',1:12,sep='.'))
    mfr = bind_cols( lapply( 1:12, function( mmm ){ dat.df$manufacturing_return } ) )	%>% as.data.frame() %>% 'names<-'(paste('manufacturing_return',1:12,sep='.'))
    dat.df = dat.df %>% 
      dplyr::select( -manufacturing_withdrawal ) %>% cbind( ., mfw ) %>%
      dplyr::select( -manufacturing_return ) %>% cbind( ., mfr )
    
    # flatten the df
    dat.df = bind_rows( lapply( c( 'urban_withdrawal', 'urban_return', 'rural_withdrawal', 'rural_return', 'manufacturing_withdrawal', 'manufacturing_return'  ), function( tp ){
      dat.df %>% 
        dplyr::select( PID, paste( tp, 1:12, sep = '.' ) ) %>%  
        gather( 'month','value',-PID) %>% 
        mutate( time = unlist( strsplit( month, '[.]' ) )[ seq(2,2*length(month),by=2) ], type = tp, scenario = paste0( 'SSP', ss ), year = yy[y], value = round( value, digits = 3 ) ) %>%
        dplyr::select( scenario, PID, type, year, time, value ) 
    } ) ) 
    
    # But the urban and rural withdrawal / return flow data are in million cubic meters per month not per day
    type2check = c( 'urban_withdrawal', 'urban_return', 'rural_withdrawal', 'rural_return' )
    dat.df = rbind( dat.df %>% filter( ! type %in% type2check ),
                    dat.df %>% filter( type %in% type2check ) %>% 
                      left_join( ., data.frame( time = as.character( 1:12 ), days = c(31, 28.25, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31) ) ) %>%
                      mutate( value = round( value / days, digits = 3 ) ) %>% dplyr::select( -days ) )
    
    # add units
    dat.df$units = 'mcm_per_day'
    # elec.df$units = 'MW'
    
    
    dat.df = rbind( dat.df) #, elec.df )
    
    return( dat.df )
    
  } ) )
  
} ) )

# Harmonize with naming convention used previously - might update later
demands.df = demands.df %>% 
  mutate( sector = unlist( strsplit( type, '_') )[seq(1,2*length(type),by=2)] ) %>%
  mutate( sector = ifelse( sector == 'manufacturing', 'industry', sector ) ) %>%
  mutate( type = unlist( strsplit( type, '_') )[seq(2,2*length(type),by=2)] ) %>%
  mutate( type = ifelse( type == 'final', 'electricity', type ) ) %>%
  dplyr::rename( pid = PID, month = time ) %>%
  dplyr::select( scenario, sector,  type,  pid,  year,  month, value, units )

write.csv( demands.df, paste0(data_path,"/water_demands/harmonized/reg/",
                              "_ssp",ssp,"_m_water_demands.csv"), row.names=FALSE )

demand.df = read.csv( 'input/indus_demands_new.csv', stringsAsFactors=FALSE )

# Plot the results

windows()
p1 = layout( matrix( c(5,5,1,2,3,4),3,2,byrow=TRUE ), widths = c(0.3,0.3), heights= c(0.05,0.3,0.3) )
hh = 1
for( tp in c('withdrawal') )
{
  for(s in c('urban','rural','industry'))
  {
    
    tmp = data.frame( do.call( cbind, lapply( unique(demand.df$scenario), function(pp){
      res = do.call( rbind, lapply( unique(demand.df$year), function(y){ 
        res2 = sum( sapply( unique(demand.df$month), function(m){ return( demand.df[ which( demand.df$sector == s & demand.df$type == tp & demand.df$year == y & demand.df$month == m & demand.df$scenario == pp ), 'value' ] ) } ) )
        return(res2)
      } ) )
      return(res)
    } ) ) )
    names(tmp) = unique(demand.df$scenario)		
    row.names(tmp) = unique(demand.df$year)	
    
    if( tp == 'withdrawal'){ yl = c('million m3 per day'); fc = 1 }
    if( tp == 'electricity'){ yl = c('Gigawatts'); fc = 1e3 }
    
    matplot( as.numeric( row.names(tmp) ), tmp/fc, type = 'l', col = c('green','blue','orange'), xlab = 'year', lty = 1, main = paste( s, tp, sep = ' - ' ), ylab = yl )
    
  }
  
}

par(mar=c(0,0,0,0))	
plot.new()
legend('bottom',legend=c('SSP1','SSP2','SSP5'),col = c('green','blue','orange'),lty=1,bty='n',ncol=3)

rm(list=ls())
graphics.off()
library(raster)
library(sp)
library(ncdf4)
library(rgdal)
library(rgeos)
library(maptools)
library(geosphere)
library(countrycode)
library(ggmap)
library(tidyverse)
library(yaml)
library("readxl")
#library(reticulate)

# Increase memory size
memory.limit(size = 1e6)

#this path need tobe automatize, maybe loading with retisulate a python ojects that contains the rith path.
#otherwise environment path an be used
msg_data = Sys.getenv("MESSAGE_DATA_PATH")
# message-ix-models path
msg_ix_model = Sys.getenv("MESSAGE-IX-MODELS")
data_subf = path.expand(paste0(msg_data,'\\data\\water\\ppl_cooling_tech'))

all_units = read_excel('P:/ene.model/NEST/ppl_cooling_tech/PLATTS_3.7.xlsx')

all_units.df = all_units %>% select(UNIT,STATUS,ISO,msgregion, msg_combo2,cool_group_msg,MW_x,WW,WC,lat,long)
# here we need to adapt for a different regional conigurations of the GLOBAL model

for (reg in c('R11','R12')){
# for global R11 model
  cooling_plants = all_units.df %>% filter(STATUS == 'OPR',
                                                !cool_group_msg %in% c('CHP','NCN'),
                                           !is.na(cool_group_msg),
                                           !is.na(msgregion)) %>% 
    rename(utype = msg_combo2, cooling = cool_group_msg) %>% ungroup()
  
  # get mapping from yaml file in message-ix-models
  file = paste0(msg_ix_model,'/message_ix_models/data/node/',reg,'.yaml')
  from_yaml = read_yaml(file, fileEncoding = "UTF-8" )
  names_loop = names(from_yaml)[names(from_yaml) != 'World']
  reg_map.df = data.frame()
  for (rr in names_loop){
    reg_map.df = rbind(reg_map.df,data.frame(msgregion = rr, ISO = from_yaml[[rr]]$child))
  }
  
  # add R## to the msgregions, to go the in any column
  cooling_plants = cooling_plants %>% select(-msgregion) %>% 
    left_join(reg_map.df)
  
  # add the data to the cooltech_cost_and_shares_ssp_msg.csv file
  cooltech_cost_shares = read.csv(paste0(data_subf,'/cooltech_cost_and_shares_ssp_msg.csv'),stringsAsFactors=FALSE)
  
  #### shares by message REGION #### needed to establish initial mapping
  shars_cooling_MSG_global = cooling_plants %>% group_by(utype,cooling,msgregion) %>% #change to COUNTRY
    summarise(MW_x = sum(MW_x)) %>% ungroup() %>% 
    group_by(utype,msgregion) %>% #change to COUNTRY
    mutate(cap_reg_unit = sum(MW_x)) %>% ungroup() %>% 
    mutate(shares = MW_x / cap_reg_unit) %>% 
    select(utype,cooling,msgregion,shares) %>% 
    spread(msgregion, shares)
  
  shars_cooling_MSG_global[is.na(shars_cooling_MSG_global)] = 0
  
  # mapping in order to add missing technologies
  platts_types = shars_cooling_MSG_global %>% select(utype) %>% rename(utype_pl = utype) %>% 
    mutate(match = gsub('_.*','',utype_pl)) %>% group_by(match) %>% 
    summarise(utype_pl = first(utype_pl), match = first(match))
  map_all_types = cooltech_cost_shares %>% select(utype,cooling) %>% 
    mutate(match = gsub('_.*','',utype)) %>% left_join(platts_types) %>% select(-match) %>% 
    filter(!is.na(utype_pl)) %>% distinct()
  
  # This will be the file
  write.csv(shars_cooling_MSG_global,paste0(data_subf,'/cool_techs_region_share_',reg,'.csv'),row.names = FALSE)
  
  # back to shares, change names
  new_names = paste0('mix_', names(shars_cooling_MSG_global)[!names(shars_cooling_MSG_global) %in% c('utype','cooling')] )
  names(shars_cooling_MSG_global)[!names(shars_cooling_MSG_global) %in% c('utype','cooling')] = new_names
  shars_cooling_MSG_global = shars_cooling_MSG_global %>% mutate(utype_pl = utype)
  
  # missing shares
  all_shares = map_all_types %>% 
    filter(!utype %in% unique(shars_cooling_MSG_global$utype) ) %>% 
    left_join(shars_cooling_MSG_global %>% select(-utype), by = c('utype_pl','cooling') ) %>% 
    select(-utype_pl) %>% bind_rows(shars_cooling_MSG_global)
  
  cooltech_cost_shares = cooltech_cost_shares %>%
    select(utype,	cooling,investment_million_USD_per_MW_low,	investment_million_USD_per_MW_mid,	investment_million_USD_per_MW_high) %>% 
    left_join(all_shares)
  
  cooltech_cost_shares[is.na(cooltech_cost_shares)] = 0
  # write new file
  write.csv(cooltech_cost_shares,paste0(data_subf,'/cooltech_cost_and_shares_ssp_msg_',reg,'.csv'),row.names = FALSE)
}

#### SHARES by COUNTRY ####
#shares by message REGION
shars_cooling_country = cooling_plants %>% group_by(utype,cooling,ISO) %>% #change to COUNTRY
  summarise(MW_x = sum(MW_x)) %>% ungroup() %>% 
  group_by(utype,ISO) %>% #change to COUNTRY
  mutate(cap_reg_unit = sum(MW_x)) %>% ungroup() %>% 
  mutate(shares = MW_x / cap_reg_unit) %>% 
  select(utype,cooling,ISO,shares) %>% 
  spread(ISO, shares)

shars_cooling_country[is.na(shars_cooling_country)] = 0

# This will be the file
write.csv(shars_cooling_country,paste0(data_subf,'/cool_techs_country_share.csv'),row.names = FALSE)

# back to shares, change names
new_names = paste0('mix_', names(shars_cooling_country)[!names(shars_cooling_country) %in% c('utype','cooling')] )
names(shars_cooling_country)[!names(shars_cooling_country) %in% c('utype','cooling')] = new_names
shars_cooling_country = shars_cooling_country %>% mutate(utype_pl = utype)

# missing shares
all_shares_c = map_all_types %>% 
  filter(!utype %in% unique(shars_cooling_country$utype) ) %>% 
  left_join(shars_cooling_country %>% select(-utype), by = c('utype_pl','cooling') ) %>% 
  select(-utype_pl) %>% bind_rows(shars_cooling_country)

cooltech_cost_shares_c = cooltech_cost_shares %>%
  select(utype,	cooling,investment_million_USD_per_MW_low,	investment_million_USD_per_MW_mid,	investment_million_USD_per_MW_high) %>% 
  left_join(all_shares_c)

cooltech_cost_shares_c[is.na(cooltech_cost_shares_c)] = 0
# write new file
write.csv(cooltech_cost_shares_c,paste0(data_subf,'/cooltech_cost_and_shares_country.csv'),row.names = FALSE)


# OLD DATABASE, with the new one, most of this processing is done already by the script
# https://github.com/OFR-IIASA/message_data/blob/RES_add_5_year_timesteps2/data/model/platts_historical_capacity/merge_WEPP_Raptis_CARMA.py

# # loading
# temp = readOGR(path.expand(paste0(data_subf,'\\delineation')),'MSG11_reg_simpl',verbose=FALSE)
# 
# # the input shape file should come externally, in some model setup
# # usually it has two columns, the first should be called 'PID', the second 'REGION'
# # only the second column matter in terms of name, and should have the region names used in the model
# 
# region_units.spdf = spTransform(temp, CRS("+proj=longlat"))
# rm(temp)

# # Read in Raptis et al data
# ppl.df = data.frame(read.csv(paste0(data_subf,'/ppl_cooling_tech/POWER_PLANTS_2016_Raptis.csv'),stringsAsFactors=FALSE))
# raptis_types_map_cooling.df = data.frame(read.csv(paste0(data_subf,'/ppl_cooling_tech/raptis_types_map_cooling_type.csv'),stringsAsFactors=FALSE))
# raptis_types_map_unit.df = data.frame(read.csv(paste0(data_subf,'/ppl_cooling_tech/raptis_types_map_unit_type.csv'),stringsAsFactors=FALSE))
# 
# # MESSAGE technologies
# msg_types.df = data.frame(read.csv(paste0(data_subf,'/ppl_cooling_tech/tech_names_ssp_msg.csv'),stringsAsFactors=FALSE))
# msg_ppl = unique(c(raptis_types_map_unit.df$msgssp_type,raptis_types_map_unit.df$alt1,raptis_types_map_unit.df$alt2,raptis_types_map_unit.df$alt3))
# msg_ppl = msg_ppl[-1*(which(msg_ppl==''))]
# msg_cool = unique(raptis_types_map_cooling.df$msgssp_type)
# 
# fuel_group = lapply(1:length(msg_ppl),function(x){ 
# 	ind1 = which( as.character(raptis_types_map_unit.df$msgssp_type) == as.character(msg_ppl[x]) | as.character(raptis_types_map_unit.df$alt1) == as.character(msg_ppl[x]) | as.character(raptis_types_map_unit.df$alt2) == as.character(msg_ppl[x]) | as.character(raptis_types_map_unit.df$alt3) == as.character(msg_ppl[x]) )
# 	return(unique(unlist(strsplit(  as.character(raptis_types_map_unit.df$raptis_type[ind1]),'[.]' ))[seq(1,length(unlist(strsplit(  as.character(raptis_types_map_unit.df$raptis_type[ind1]),'[.]' ))),b=2)]))   
# 	})
# 
# utype = lapply(1:length(msg_ppl),function(x){ 
# 	ind1 = which( as.character(raptis_types_map_unit.df$msgssp_type) == as.character(msg_ppl[x]) | as.character(raptis_types_map_unit.df$alt1) == as.character(msg_ppl[x]) | as.character(raptis_types_map_unit.df$alt2) == as.character(msg_ppl[x]) | as.character(raptis_types_map_unit.df$alt3) == as.character(msg_ppl[x]) )
# 	return(unique(unlist(strsplit(  as.character(raptis_types_map_unit.df$raptis_type[ind1]),'[.]' ))[seq(2,length(unlist(strsplit(  as.character(raptis_types_map_unit.df$raptis_type[ind1]),'[.]' ))),b=2)]))   
# 	}	)
# 
# cool = lapply(1:length(msg_cool),function(x){ as.character(raptis_types_map_cooling.df$raptis_type[which( as.character(raptis_types_map_cooling.df$msgssp_type) == as.character(msg_cool[x]) )])})
# 	
# # Pull out data for this specific technology for each region
# cool_techs = unlist(lapply(1:length(msg_cool), function(x){as.matrix(unlist(lapply(1:length(msg_ppl),function(y){paste(msg_ppl[y],msg_cool[x],sep='.')})))}))
# xs = rep(seq(1,length(msg_ppl),by=1),length(msg_cool))
# ys = unlist(lapply(1:length(msg_cool),function(dd){ rep(dd,length(msg_ppl)) })) 
# 
# # Cooling techs by pid
# cool_techs_by_pid = data.frame(do.call(rbind, lapply(1:length(cool_techs), function(z){
# 	xx = xs[z]
# 	yy = ys[z]
# 	temp = ppl.df[which( as.character(ppl.df$Fuel_group) %in% as.character(fuel_group[[xx]]) &
# 	                       as.character(ppl.df$UTYPE) %in% as.character(utype[[xx]]) & 
# 	                       as.character(ppl.df$COOL_complete) %in% as.character(cool[[yy]]) ),]
# 	if(nrow(temp)>0)
# 		{
# 		temp$x = temp$long
# 		temp$y = temp$lat
# 		coordinates(temp) = ~ x + y
# 		proj4string(temp) = proj4string(region_units.spdf)
# 		temp$pid = unlist(over(temp,region_units.spdf[,which(names(region_units.spdf) == 'PID')]))
# 		temp = temp[-1*(which(is.na(temp$pid) | is.na(temp$MW))),]
# 		mw_by_pid = unlist(lapply(1:length(region_units.spdf@data$PID), function(bb){ max(0, sum( temp$MW[ which( as.character(temp$pid) == as.character(region_units.spdf@data$PID[bb]) ) ], na.rm=TRUE ), na.rm=TRUE) } ) )
# 		return(mw_by_pid)
# 		}else
# 		{
# 		mw_by_pid  = rep(0,length(region_units.spdf@data$REGION))
# 		return(mw_by_pid)
# 		}	
# 	})))
# row.names(cool_techs_by_pid) = cool_techs
# 	
# type_general = unlist(strsplit( cool_techs, '[.]' ))[seq(1,length(unlist(strsplit( cool_techs, '[.]' ))),by=2)]
# cool_general = unlist(strsplit( cool_techs, '[.]' ))[seq(2,length(unlist(strsplit( cool_techs, '[.]' ))),by=2)]
# cool_techs_shares_by_pid = data.frame( do.call( cbind, lapply(1:length(region_units.spdf@data$REGION), function(r){ as.matrix( unlist( lapply( 1:length(cool_techs), function(z){
# 	share =  cool_techs_by_pid[z,r] / sum( c( cool_techs_by_pid[ which( as.character(type_general) == as.character(type_general[z]) ), r] ), na.rm = TRUE)
# 	if( is.na(share) | length(share) == 0 ){share =  round( sum( c( cool_techs_by_pid[ which( as.character(cool_general) == as.character(cool_general[z]) ), r] ), na.rm = TRUE) / sum( c( cool_techs_by_pid[ , r] ), na.rm = TRUE), digits = 3)}
# 	return(round(share, digits = 3)) } ) ) ) } ) ) )	
# row.names(cool_techs_shares_by_pid) = cool_techs		
# names(cool_techs_shares_by_pid) = 	as.character(region_units.spdf@data$REGION)	
# cool_techs_shares_by_pid$cooling_utype = as.character(cool_techs)
# cool_techs_shares_by_pid$cooling = as.character(cool_general)
# cool_techs_shares_by_pid$utype = as.character(type_general)
# cool_techs_shares_by_pid = cool_techs_shares_by_pid[,c('utype','cooling',as.character(region_units.spdf@data$REGION))]
# cool_techs_shares_by_pid = cool_techs_shares_by_pid[ order( cool_techs_shares_by_pid$utype ), ]
# 
# # This will be the file
# write.csv(cool_techs_shares_by_pid,paste0(data_subf,'/cool_techs_region_share.csv'),row.names = FALSE)
# 
# #add 'mix_' to the columns names for regions
# cool_techs_shares_by_pid2 = cool_techs_shares_by_pid
# new_names = paste0('mix_', names(cool_techs_shares_by_pid2)[!names(cool_techs_shares_by_pid2) %in% c('utype','cooling')] )
# names(cool_techs_shares_by_pid2)[!names(cool_techs_shares_by_pid2) %in% c('utype','cooling')] = new_names
# 
# # add the data to the cooltech_cost_and_shares_ssp_msg.csv file
# cooltech_cost_shares = read.csv(paste0(data_subf,'/cooltech_cost_and_shares_ssp_msg.csv'),stringsAsFactors=FALSE)
# cooltech_cost_shares = cooltech_cost_shares %>% 
#   select(utype,	cooling,investment_million_USD_per_MW_low,	investment_million_USD_per_MW_mid,	investment_million_USD_per_MW_high) %>% 
#   left_join(cool_techs_shares_by_pid2)
# 
# # write new file
# write.csv(cool_techs_shares_by_pid,paste0(data_subf,'/cooltech_cost_and_shares_ssp_msg.csv'),row.names = FALSE)

require(reshape)
require(rgdal)
require(raster)
require(rgeos)
require(tidyr)
require(dplyr)
require(maptools)
require(ncdf4)
library(sp)
library(countrycode)
library(ggmap)
library(sf)
library(exactextractr)

nc = nc_open(
    paste0(
        "C:/Users/awais/Documents/GitHub/agg_data/output/dis_5y__hadgem2-es_rcp60_temp_agg.nc"
    ),
    verbose=FALSE,
)
nc.brick = brick(
    "C:/Users/awais/Documents/GitHub/agg_data/output/qtot_5y__gfdl-esm2m_rcp60_temp_agg.nc"
)


basin < -read.csv(
    "C:/Users/awais/Documents/GitHub/agg_data/output/basins_by_region_simpl_R11.csv"
)

# load shapefile
basin_by_region.spdf = read_sf(
    "P:/ene.model/NEST/delineation/data/delineated_basins_new",
    paste0("basins_by_region_simpl_R11"),
)


agg < -exact_extract(nc.brick, basin_by_region.spdf, "sum")


output < -cbind(basin, agg)

write.csv(
    output,
    "C:/Users/awais/Documents/GitHub/agg_data/output/qtot_5y__gfdl-esm2m_rcp60_temp_agg.nc",
)

basin < -read.csv(
    "C:/Users/awais/Documents/GitHub/agg_data/output/basins_by_region_simpl_R11.csv"
)

#source('P:/ene.model/NEST/groundwater/groundwater_harmonize.r')

# Clear memory 
rm(list = ls()) 

# close all plot windows
graphics.off() 

# libraries
library(raster)
library(rgdal)
require(rgeos)
library(ncdf4)
library(tidyverse)

#### REGION ####
# define what region you work on
# R11, R12 or a country
reg = 'ZMB'

# Define global raster at 1/8th degree
base_raster = raster()
res(base_raster) = 1/8
base_raster = crop(base_raster,extent(-180,180,-60,85))
base_raster[] = 0

# Continental Tiles
tile_names = c('Africa','Australia','Eurasia','N_America','S_America')
for (i in 1:length(tile_names))
	{
	
	# Import data from netcdf and convert to raster aligned with base raster
  # unit meters m
	nc_filename = paste(tile_names[i],'_model_wtd_v2.nc',sep='')
	folder = c('P:/ene.model/NEST/groundwater/table_depth/')
	raster_shape = raster(paste(folder,nc_filename,sep=''), varname='WTD') # doesn't seem to work for this type of ncdf file but provides shape
	nc = nc_open(paste(folder,nc_filename,sep=''))
	wtd = t(ncvar_get(nc, 'WTD')) # transpose and flip
	wtd = wtd[nrow(wtd):1,]
	wtd.raster = raster(wtd)
	extent(wtd.raster) = extent(raster_shape)
	proj4string(wtd.raster) = proj4string(raster_shape)
	wtd.raster = projectRaster( from = wtd.raster , to = base_raster , method = "bilinear" )
	
	# Add to global raster
	if(i == 1)
		{
		global_water_table_depth_0125 = wtd.raster
		}else
		{
		global_water_table_depth_0125 = do.call(merge, list(global_water_table_depth_0125, wtd.raster))
		}
	}

# Write to geotiff
temp = writeRaster(global_water_table_depth_0125, paste(folder,'global_water_table_depth_0125',sep=''), format = 'GTiff', overwrite = TRUE)

#### TAKE MESSAGE REGION-BASIN structure ####
basin_by_region.spdf = readOGR('P:/ene.model/NEST/delineation/data/delineated_basins_new',
                               paste0('basins_by_region_simpl_',reg), verbose=FALSE)
row.names(basin_by_region.spdf@data) = 1:length(basin_by_region.spdf$BASIN)
# basin_by_region.spdf2 = gBuffer(basin_by_region.spdf, byid=TRUE, width=-0.2)

proj4string(global_water_table_depth_0125) = basin_by_region.spdf@proj4string
identicalCRS(global_water_table_depth_0125, basin_by_region.spdf)

table_depth.df  = raster::extract(global_water_table_depth_0125, basin_by_region.spdf,fun=mean,df=TRUE,na.rm=TRUE)
names(table_depth.df) = c('id','table_depth_m')
table_depth.spdf = cbind(basin_by_region.spdf, table_depth.df)
library(broom)
table_depth.tidy <- broom::tidy(table_depth.spdf)
table_depth.tidy2 <- dplyr::left_join(table_depth.tidy %>% mutate(id = as.integer(id)),
                                table_depth.spdf@data, by='id')
# table_depth.tidy2 = table_depth.tidy2[table_depth.tidy2$BASIN_ID %in% c(64), ]
# plot mismatch regions...
ggplot() + 
  geom_polygon( data=table_depth.tidy2, aes(x=long, y=lat, group = group, fill = table_depth_m),
                color="black" )

#some regions are not plotted correctly but the data is there
table_depth.out = table_depth.spdf@data %>% 
  mutate(table_depth_m = if_else(is.na(table_depth_m), 
                                 mean(table_depth_m,na.rm = T) , table_depth_m),
         # Energy use in GW / MCM/day
         GW_per_MCM_per_day = round( 0.85 * 9.81 / 86400 * table_depth_m , digits = 5 ),
         # in GW/km3/year 
         GW_per_km3_per_year = GW_per_MCM_per_day *1000/365)
# to be changed to the unit we need

write.csv( table_depth.out, paste0('gw_energy_intensity_depth_',reg,'.csv'), row.names = FALSE)	


#### GW abstraction, historical capaicty ####
# 1- get historical and projections for abstraction (only use hist for now)
# 2- from Wada et al, also import different water demands
# 3- gw_fraction = tot_demand / gw abstraction
# 4- use gw_fraction on our actual demands in the model -> historical capacity
setwd('P:/ene.model/NEST/groundwater/')
# Groundwater abstraction fro Wada et al

nc = nc_open('Wada_groundwater_abstraction/waterdemand_30min_groundwaterabstraction_million_m3_month.nc', verbose=FALSE)
gwabstract.stack = stack( 'Wada_groundwater_abstraction/waterdemand_30min_groundwaterabstraction_million_m3_month.nc' )
extent(gwabstract.stack) = extent( min( ncvar_get(nc, "longitude") ), max( ncvar_get(nc, "longitude") ), min( ncvar_get(nc, "latitude") ), max( ncvar_get(nc, "latitude") ) )
proj4string( gwabstract.stack ) = proj4string( basin_by_region.spdf )
#gwabstract.stack = crop( gwabstract.stack, extent(basin_by_region.spdf) )
names(gwabstract.stack) = c( sapply( 1:(nlayers(gwabstract.stack)/12), function(yy){ return( paste( ( as.numeric( unlist( strsplit( as.character( as.Date("1901-01-01") + min( ncvar_get(nc, "time") ) ), '-' ) )[1] ) + yy - 1 ), seq(1,12,by=1), sep='.') ) } ) ) 
gwabstract.stack = gwabstract.stack[[ c( which(grepl( 'X2010',names(gwabstract.stack) )) ) ]] # keep 2010

# Irrigation
nc = nc_open('Wada_groundwater_abstraction/pcrglobwb_WFDEI_historical_PIrrWW_monthly_1960_2010.nc4', verbose=FALSE)
irrigation.stack = stack( 'Wada_groundwater_abstraction/pcrglobwb_WFDEI_historical_PIrrWW_monthly_1960_2010.nc4' )
extent(irrigation.stack) = extent( min( ncvar_get(nc, "longitude") ), max( ncvar_get(nc, "longitude") ), min( ncvar_get(nc, "latitude") ), max( ncvar_get(nc, "latitude") ) )
proj4string( irrigation.stack ) = proj4string( basin_by_region.spdf )
# irrigation.stack = crop( irrigation.stack, extent(buff.sp) )
names(irrigation.stack) = c( sapply( 1:(nlayers(irrigation.stack)/12), function(yy){ return( paste( ( as.numeric( unlist( strsplit( as.character( as.Date("1901-01-01") + min( ncvar_get(nc, "time") ) ), '-' ) )[1] ) + yy - 1 ), seq(1,12,by=1), sep='.') ) } ) ) 
irrigation.stack = irrigation.stack[[ c( which(grepl( 'X2010',names(irrigation.stack) )) ) ]] # keep 2010

year_irr = sum(irrigation.stack)
tot_km3 = sum(year_irr@data@values,na.rm = T)*0.001
# Industrial
nc = nc_open('Wada_groundwater_abstraction/pcrglobwb_WFDEI_historical_PIndWW_monthly_1960_2010.nc4', verbose=FALSE)
industrial.stack = stack( 'Wada_groundwater_abstraction/pcrglobwb_WFDEI_historical_PIndWW_monthly_1960_2010.nc4' )
extent(industrial.stack) = extent( min( ncvar_get(nc, "longitude") ), max( ncvar_get(nc, "longitude") ), min( ncvar_get(nc, "latitude") ), max( ncvar_get(nc, "latitude") ) )
proj4string( industrial.stack ) = proj4string( basin_by_region.spdf )
# industrial.stack = crop( industrial.stack, extent(buff.sp) )
names(industrial.stack) = c( sapply( 1:(nlayers(industrial.stack)/12), function(yy){ return( paste( ( as.numeric( unlist( strsplit( as.character( as.Date("1901-01-01") + min( ncvar_get(nc, "time") ) ), '-' ) )[1] ) + yy - 1 ), seq(1,12,by=1), sep='.') ) } ) ) 
industrial.stack = industrial.stack[[ c( which(grepl( 'X2010',names(industrial.stack) )) ) ]] # keep 2010

# Domestic
nc = nc_open('Wada_groundwater_abstraction/pcrglobwb_WFDEI_historical_PDomWW_monthly_1960_2010.nc4', verbose=FALSE)
domestic.stack = stack( 'Wada_groundwater_abstraction/pcrglobwb_WFDEI_historical_PDomWW_monthly_1960_2010.nc4' )
extent(domestic.stack) = extent( min( ncvar_get(nc, "longitude") ), max( ncvar_get(nc, "longitude") ), min( ncvar_get(nc, "latitude") ), max( ncvar_get(nc, "latitude") ) )
proj4string( domestic.stack ) = proj4string( basin_by_region.spdf )
# domestic.stack = crop( domestic.stack, extent(buff.sp) )
names(domestic.stack) = c( sapply( 1:(nlayers(domestic.stack)/12), function(yy){ return( paste( ( as.numeric( unlist( strsplit( as.character( as.Date("1901-01-01") + min( ncvar_get(nc, "time") ) ), '-' ) )[1] ) + yy - 1 ), seq(1,12,by=1), sep='.') ) } ) ) 
domestic.stack = domestic.stack[[ c( which(grepl( 'X2010',names(domestic.stack) )) ) ]] # keep 2010

# Existing groundwater capacity from initial extraction levels
total.stack = domestic.stack + industrial.stack + irrigation.stack
total.stack  =  sum(stack(total.stack))
total_gwabstract.stack = sum(stack(gwabstract.stack))
gwfraction.stack = ( total_gwabstract.stack / total.stack )
# areas with 0 demand nad maybe little vals of gw abstraction
# otherwise results in 100% where actually gw is minimal, no demand
gwfraction.stack[gwfraction.stack == Inf] = 0
gwfraction.stack[gwfraction.stack[]>1]=1
gwfraction.stack[is.na(gwfraction.stack)] = 0


frac = c( unlist( lapply( 1:length(basin_by_region.spdf), function(x){ 
  
  gw = sum( data.frame( raster::extract( total_gwabstract.stack, as(basin_by_region.spdf[x,],'SpatialPolygons'), na.rm=TRUE, cellnumbers = TRUE )[[1]])['value'] )
  
  ww = sum( data.frame( raster::extract( total.stack, as(basin_by_region.spdf[x,],'SpatialPolygons'), na.rm=TRUE, cellnumbers = TRUE )[[1]])['value'] )
  
  return( round( min( 1, max( 0, gw/ww, na.rm=TRUE ) ), digits = 3 ) ) 
  
} ) ) )

# Data frame output by PID
groundwater_fraction.df = data.frame( gw_fraction = frac ) %>% 
  mutate(id = row_number(),
         # many values close to 0 are bo due to lack of data
         gw_fraction = if_else(gw_fraction <= 0.02,mean(gw_fraction),gw_fraction))
groundwater_fraction.spdf = cbind(basin_by_region.spdf,groundwater_fraction.df) 

writeOGR(
  groundwater_fraction.spdf, 
  'P:/ene.model/NEST/groundwater', 
  paste0('gw_fraction_',reg),
  driver="ESRI Shapefile", 
  overwrite_layer=TRUE
)

gw_fraction.tidy <- broom::tidy(groundwater_fraction.spdf)
gw_fraction.tidy2 <- dplyr::left_join(gw_fraction.tidy %>% mutate(id = as.integer(id)),
                                      groundwater_fraction.spdf@data, by='id')
gw_fraction.tidy2 = gw_fraction.tidy2[gw_fraction.tidy2$BASIN_ID %in% c(64), ]
# this plot is completely wrong!! use ArcGIS instead
ggplot() + 
  geom_polygon( data=gw_fraction.tidy2, aes(x=long, y=lat, group = group, fill = gw_fraction),
                color="black" )

# Now use the groundwater fraction to set the historical capacities based on the historical demand level
# load all demands
## CAREFUL! irr_dem needs to be manually defined
# for R11 it is from GLOBIOM, in MCM
irr_dem = read.csv(paste0('P:/ene.model/NEST/groundwater/hist_irrigation_withdrawals_',reg,'.csv'),
                   check.names = F) %>% 
  gather(key = 'year',value = 'irr_dem',-node) %>% rename(REGION = node) %>% 
  mutate(year = as.numeric(year))
# urban + manufacturing and rural demand depend on the region, in MCM!!
urban_man_dem = read.csv(paste0('P:/ene.model/NEST/water_demands/harmonized/',
                                reg,'/ssp2_regional_urban_withdrawal_baseline.csv'),
                         check.names = F) %>% rename(year = '') %>% 
  gather(key = 'BCU_name',value = 'urb_dem',-year) %>% 
  mutate(urb_dem = urb_dem/1000) # km3

rural_dem = read.csv(paste0('P:/ene.model/NEST/water_demands/harmonized/',
                            reg,'/ssp2_regional_rural_withdrawal_baseline.csv'),
                     check.names = F) %>% rename(year = '') %>% 
  gather(key = 'BCU_name',value = 'rur_dem',-year) %>% 
  mutate(rur_dem = rur_dem/1000) # km3

#specific region name for R11 or R12
if (reg %in% c(" R11"," R12")){
  reg_add = paste0(reg,"_")
} else{
  reg_add = ""
}
tot_demand = urban_man_dem %>% left_join(rural_dem) %>% 
  left_join(basin_by_region.spdf@data %>% select(REGION,BCU_name) %>% 
              mutate(REGION = paste0(reg_add,REGION))) %>% 
  filter(year == 2010) %>% 
  left_join(irr_dem) %>% 
  group_by(REGION) %>% 
  mutate(tot_urb_reg_wtr = sum(urb_dem),
         region_water_share = urb_dem  / tot_urb_reg_wtr) %>% ungroup() %>% 
  #use this share to allocate irrigation withdrawals to basins
  mutate(irr_dem_bas = irr_dem * region_water_share,
         tot_dem = irr_dem_bas + urb_dem + rur_dem)

hist_cap_gw_sw = tot_demand %>% select(BCU_name,tot_dem) %>% 
  left_join(groundwater_fraction.spdf@data %>% select(BCU_name,gw_fraction)) %>% 
  mutate(hist_cap_gw_km3_year = round( tot_dem * gw_fraction,3 ),
         hist_cap_sw_km3_year = round( tot_dem * (1- gw_fraction) ,3) ) %>% 
  select(-tot_dem,-gw_fraction)

### Append historical capacity csv to include freshwater extration capacities

# historical capacity csv
write.csv( 	hist_cap_gw_sw, 
            paste0("historical_new_cap_gw_sw_km3_year_",reg,".csv"), 
            row.names = FALSE )

# Clear memory and close all windows
rm(list = ls())
graphics.off()

require(reshape)
require(maptools)
require(countrycode)
require(raster)
require(rgeos)
require(rgdal)
require(ncdf4)
require(tidyverse)

memory.limit(size=1e9)

# message-ix-models path
msg_ix_model = Sys.getenv("MESSAGE-IX-MODELS")
## Set path data folder in message_ix working copy
msg_data = paste0('P:/ene.model/NEST')
data_path = path.expand(msg_data)

crs = "+proj=longlat +datum=WGS84 +no_defs"

# Country region mapping key
country_region_map_key.df = data.frame( read.csv( paste( data_path, '/water_demands/country_region_map_key.csv',  sep = '/' ), stringsAsFactors=FALSE) )

# ssp
ssp = 2

# Load municipal water demands and socioeconomic parameters from local drive
dat.df = merge_recurse( lapply( seq(2010,2090,by=10), function(y){

  dat.df = data.frame( readRDS( paste(data_path,'/harmonized_rcp_ssp_data/water_use_ssp2_rcp2_',y,'_data.Rda',sep='') ) )
  dat.df = cbind( dat.df[ ,c('country_id', paste('xloc',y,sep= '.'), paste('yloc', y, sep= '.'), paste('urban_pop', y, sep= '.'), paste('rural_pop', y, sep= '.'), paste('urban_gdp', y, sep= '.'), paste('rural_gdp', y, sep= '.') ) ],
                  rowSums( do.call( cbind, lapply( 1:12, function(m){ dat.df[ ,paste('urban_withdrawal',y,m,sep= '.') ] } ) ) ),
                  rowSums( do.call( cbind, lapply( 1:12, function(m){ dat.df[ ,paste('rural_withdrawal',y,m,sep= '.') ] } ) ) ),
                  rowSums( do.call( cbind, lapply( 1:12, function(m){ dat.df[ ,paste('urban_return',y,m,sep= '.') ] } ) ) ),
                  rowSums( do.call( cbind, lapply( 1:12, function(m){ dat.df[ ,paste('rural_return',y,m,sep= '.') ] } ) ) ),
                  rowSums( do.call( cbind, lapply( 1:12, function(m){ dat.df[ ,paste('urban_withdrawal',y,m,sep= '.') ] } ) ) ) / dat.df[, paste('urban_pop', y, sep= '.') ],
                  rowSums( do.call( cbind, lapply( 1:12, function(m){ dat.df[ ,paste('rural_withdrawal',y,m,sep= '.') ] } ) ) ) / dat.df[, paste('rural_pop', y, sep= '.') ]	)
  names(dat.df) = c('country_id', 'xloc', 'yloc', paste('urban_pop',y,sep= '.'), paste('rural_pop', y, sep= '.'), paste('urban_gdp', y, sep= '.'), paste('rural_gdp', y, sep= '.'), paste('urban_withdrawal', y, sep= '.'), paste('rural_withdrawal', y, sep= '.'), paste('urban_return', y, sep= '.'), paste('rural_return', y, sep= '.'), paste('urban_per_capita_withdrawal', y, sep= '.'), paste('rural_per_capita_withdrawal', y, sep= '.') )

  # Make sure return flows don't exceed withdrawals
  inds = which( unlist( dat.df[, paste('urban_return',y,sep= '.') ] ) > 0.92 * unlist(dat.df[, paste('urban_withdrawal', y, sep= '.') ] ) )
  if( length(inds)>0 ){ dat.df[ inds, paste('urban_return',y,sep= '.') ] = dat.df[inds, paste('urban_withdrawal', y, sep= '.') ] * 0.92 }
  inds = which( unlist( dat.df[, paste('rural_return',y,sep= '.') ] ) > 0.92 * unlist(dat.df[, paste('rural_withdrawal', y, sep= '.') ] ) )
  if( length(inds)>0 ){ dat.df[ inds, paste('rural_return',y,sep= '.') ] = dat.df[inds, paste('rural_withdrawal', y, sep= '.') ] * 0.92 }

  # Set NA to 0
  dat.df[which(is.nan(dat.df[,12])),12] = 0
  dat.df[which(is.nan(dat.df[,13])),13] = 0
  dat.df[which(is.na(dat.df[,12])),12] = 0
  dat.df[which(is.na(dat.df[,13])),13] = 0

  return(dat.df)

} ), by = c('xloc','yloc','country_id') )

dat.df[is.na(dat.df)] = 0

# year interpolation
var_2_intpl = unique(gsub('\\..*','',names(dat.df)))
var_2_intpl = var_2_intpl[!var_2_intpl %in% c('xloc','yloc','country_id')]
initial_years = unique(gsub('.*\\.','',names(dat.df)))
initial_years = as.numeric(initial_years[!initial_years %in% c('xloc','yloc','country_id')])
yrs = initial_years

yrs = seq(2010,2090,by=10)

# Countries, regions and basins
# Here we can add specification in case of a country model
dat.df$country = sapply( dat.df$country_id, function(cc){ if( cc %in% country_region_map_key.df$UN_Code )
{ return( country_region_map_key.df$ISO3[ which(country_region_map_key.df$UN_Code == cc) ] ) 
}else{ return(NA) } } )
dat.df$R11 = sapply( dat.df$country_id, function(cc){ if( cc %in% country_region_map_key.df$UN_Code )
{ return( country_region_map_key.df$R11[ which(country_region_map_key.df$UN_Code == cc) ] ) 
}else{ return(NA) } } )
dat.df$R12 = sapply( dat.df$country_id, function(cc){ if( cc %in% country_region_map_key.df$UN_Code )
{ return( country_region_map_key.df$R12[ which(country_region_map_key.df$UN_Code == cc) ] ) 
}else{ return(NA) } } )
# dat.df = dat.df[which(!is.na(dat.df$R11)),]

#### Make spatial####
dat.spdf = dat.df
coordinates(dat.spdf) = ~ xloc + yloc

# Add distance to coastline
coast = readShapeLines('P:/ene.model/data/Water/ne_10m_coastline/ne_10m_coastline.shp')
#distance2coast = sapply( 1:nrow(dat.spdf), function(x){  gDistance( dat.spdf[x,], coast ) } )
#write.csv( distance2coast, 'C:/Users/parkinso/Documents/distance2coastssp2.csv', row.names=FALSE )
distance2coast = data.frame( read.csv( 'P:/ene.model/data/Water/distance2coastssp2.csv', stringsAsFactors = FALSE ) )
dat.spdf$distance2coast = distance2coast$x  # in degrees

# number of grid cells close to the coast
presence_of_coast = dat.spdf@data %>% filter(distance2coast <= 1.5) %>% 
  mutate(num = as.numeric(1) ) %>% select(country,distance2coast,num) %>% 
  group_by(country) %>% 
  summarise(num = sum(num))
write.csv(presence_of_coast,'P:/ene.model/NEST/desalination/coast.csv',row.names = F)
  
# some northern countries seem to not be included TOCHECK
# a = dat.spdf[,'distance2coast']
# a$distance2coast = as.numeric(a$distance2coast)/0.125
# gridded(a) = TRUE
# windows()
# plot(a )
# plot( coast, add=TRUE)
# rm(a)

#read in raster from ED. ATTENTION 2100 and 2110 missing
nc = nc_open( paste0(data_path,'/water_scarcity/wsi_memean_ssp2_rcp6p0.nc'), verbose=FALSE)
watstress.brick = brick( paste0(data_path,'/water_scarcity/wsi_memean_ssp2_rcp6p0.nc') )
proj4string(dat.spdf) = proj4string(watstress.brick)
for (i in seq(1:nlayers(watstress.brick)) ){
    r <- raster(watstress.brick, layer=i)
    proj4string(r) = proj4string(dat.spdf)
    yr = as.numeric(gsub('X','',gsub('s','',names(r)) ))
    if (yr %in% initial_years){
      column_name = paste0('WSI.', yr )
      dat.spdf@data[,column_name] = raster::extract(r,dat.spdf)
      # there are 876 Na values, we set them = 0
      dat.spdf@data[column_name][is.na(dat.spdf@data[column_name])] = 0
      } else {}

}

dat.df = bind_cols(as.data.frame(dat.spdf@coords),dat.spdf@data)

## END TESTING

# OLD PART TO REMOVE
# Add water stress level - map to gridded withdrawals

# temp = readOGR('P:/ene.model/data/Water','water_scarcity',verbose=FALSE)
# temp = SpatialPolygonsDataFrame(as(temp,'SpatialPolygons'), data.frame(temp), match.ID = TRUE)
# all_bas = temp
# all_bas@data$PID = as.character( all_bas$ECOREGION )
# temp = temp[ which(as.character( temp@data$wtr_stress ) %in% c( 'Stress','High stress','Low stress') ), ]
# temp@data$ID = 1
# temp@data$ID2 = sapply( as.character( temp@data$wtr_stress ), function(st){ if(st == 'Stress'){return(0.75)}; if(st == 'High stress'){return(1)}; if(st == 'Low stress'){return(0.6)} } )
# temp = temp[ ,c('ID2') ]
# temp@data$ID = as.numeric( temp@data$ID2 )
# temp@data$PID = row.names( temp )
# proj4string(dat.spdf) = proj4string(temp)
# dat.df = cbind( data.frame(dat.spdf), over( dat.spdf,temp ) )
# rm( dat.spdf )
# dat.df$ID[ which( is.na( dat.df$ID ) ) ] = 0

## END PARt TO REMOVE

#### GOVERNANCE ####
length(unique(dat.df$country))
gov.df = read.csv(paste0(data_path,'/governance/governance_obs_project.csv')) %>%
  filter(!is.na(governance)) %>%
  filter(scenario == paste0('SSP',ssp), year %in% initial_years ) %>%
  dplyr::select(countrycode, year, governance)
names(gov.df)
mean_gov = mean(gov.df$governance)
# missing countries, just add mean_gov
to_add = data.frame(countrycode = c('AFG','AGO', 'ALB', 'ARE','MNE', 'MMR', 'PSE', 'QAT', 'TLS','TWN'), governance = mean_gov) %>%
  crossing(year = unique(gov.df$year)) %>%
  dplyr::select(countrycode,year,governance)

gov.df = gov.df %>% bind_rows(to_add) %>%
  dplyr::rename(gov = year, country = countrycode) %>%
  spread(gov,governance, sep = '.')

dat.df = dat.df %>% left_join(gov.df)
#countries that have no governance values
dat.df %>% filter(is.na(gov.2020)) %>%
  distinct(country) # not anymore

#re-add to dat.spdf
dat.spdf = dat.df
coordinates(dat.spdf) = ~ xloc + yloc

#### Existing urban wastewater treatment ####
# WARNING: loading this file or the 'over' function MIGHT TAKE HOURS
# WRI aquedoct. 
# https://www.wri.org/data/aqueduct-global-maps-30-data
# wri_map.spdf = readShapeLines('P:/ene.model/NEST/water_access/Y2019M07D12_Aqueduct30_V01/wri.shp',
#                               delete_null_obj=TRUE)
wri_map.spdf = readOGR('P:/ene.model/NEST/water_access/Y2019M07D12_Aqueduct30_V01','wri',verbose=FALSE)

wri_map.spdf = wri_map.spdf[c("udw_raw","usa_raw")]

dat_simpl.spdf = dat.spdf[c('urban_gdp.2020','rural_gdp.2020')]
dat_simpl.spdf$xcord = dat_simpl.spdf$xloc
dat_simpl.spdf$ycord = dat_simpl.spdf$yloc

# proj4string(dat_simpl.spdf) = proj4string(wri_map.spdf)
new_proj = CRS("+proj=longlat +datum=WGS84 +no_defs")
proj4string(dat_simpl.spdf) = new_proj
proj4string(wri_map.spdf) = new_proj
# dat_proj.spdf = spTransform(dat_simpl.spdf, new_proj)

wri_over = over(dat_simpl.spdf,wri_map.spdf)
identicalCRS(dat_simpl.spdf, wri_map.spdf)

dat.spdf = cbind(dat.spdf , wri_over)

vec = names(dat.spdf)[grepl('urban_gdp|rural_gdp|urban_pop|rural_pop',names(dat.spdf))]

# with new data
ww.df2 = dat.spdf@data %>%  
  select(country_id,all_of(vec), udw_raw, usa_raw) %>% 
  bind_cols(xcord = dat.spdf$xloc,ycord = dat.spdf$yloc) %>% 
  mutate(income.2020 = (urban_gdp.2020 + rural_gdp.2020)/(urban_pop.2020 + rural_pop.2020)) %>%
  # mutate(urb_income.2020 = (urban_gdp.2020)/(urban_pop.2020)) %>% 
  # mutate(rur_income.2020 = (rural_gdp.2020)/(rural_pop.2020)) %>% 
  filter(income.2020 > 0, !is.na(udw_raw), !is.na(usa_raw)) %>% 
  mutate(udw_raw = (1 - udw_raw) * 100,
         usa_raw = (1 - usa_raw) * 100) 

ww.df2_plot = ww.df2 %>% group_by(country_id) %>% 
  summarise(income.2020 = mean(income.2020),
            udw_raw = mean(udw_raw),
            usa_raw = mean(usa_raw)) %>% ungroup() %>% 
  gather(udw_raw,usa_raw, key = 'type',value = 'value')

# new
x = c(33,ww.df2$income.2020)
y = c(0.0001,ww.df2$udw_raw)
r = nls(y ~ SSlogis(x,a,m,s))
cp.a = 1
cp.m = coef(r)[2]
cp.s = coef(r)[3]
# new
y = c(0.0001,ww.df2$usa_raw)
r = nls(y ~ SSlogis(x,a,m,s))
tp.a = 1
tp.m = coef(r)[2]
tp.s = coef(r)[3]

# Plot historical connection levels and model
cpm = data.frame( x = seq( 1, 56000, by = 1000 ), y = SSlogis( seq( 1, 56000, by = 1000 ), 0.99, cp.m, cp.s ) )
tpm = data.frame( x = seq( 1, 56000, by = 1000 ), y = SSlogis( seq( 1, 56000, by = 1000 ), 0.99, tp.m, tp.s ) )

cpm$type = 'udw_raw'
tpm$type = 'usa_raw'
cpm = cpm %>% bind_rows(tpm)

type_names <- list(
  'udw_raw'="Water access",
  'usa_raw'="Sanitation"
)
type_labeller <- function(variable,value){
  return(type_names[value])
}

ggplot()+
  geom_line(data = cpm,aes(x = x, y = 100*y) )+
  geom_point(data = ww.df2_plot, aes(x = income.2020, y= value))+
  ggtitle('Model vs country averages')+
  facet_wrap(~type, labeller = type_labeller) +
  xlab('Per capita Income in 2020 [USD/pc]')+
  ylab('share of population with access [%]')+
  theme_bw()+
  theme(panel.grid.minor = element_blank())

# piped water access / sewerage connection

UR = c('urban','rural')
ww_proj = function(ww.df2,UR,yy){ 
  
  t1 = rlang::sym(paste0(UR,'_gdp.',yy))
  t2 = rlang::sym(paste0(UR,'_pop.',yy) )
  inc_f = rlang::sym(paste0(UR,'_income.',yy) )
  varc = rlang::sym(paste0(UR,'_connection_rate.',yy) )
  vart = rlang::sym(paste0(UR,'_treatment_rate.',yy) )
  decay = max( 0, 1 / length(yrs) * log( 1 / 0.01 ), na.rm=TRUE )
  
  ww.df2 %>% 
    mutate("{UR}_income.{yy}" := pmax(0, !!t1 / !!t2 ,na.rm = T) ,
           year = yy) %>% 
    mutate(c0 = udw_raw / 100,
           t0 = usa_raw / 100) %>% 
    mutate(c_mod = c( SSlogis( !!inc_f, cp.a, cp.m, cp.s ) ),
           t_mod = c( SSlogis( !!inc_f, tp.a, tp.m, tp.s ) )) %>% 
    # 2020 is base year, 2010 need smaller values, 2010 need to changed at the end or not calculated
    mutate(!!varc := pmin(0.999, if_else(year == 2010, 0.95*c0,
                                         ( 1 +  ( c0 / c_mod - 1 ) * 
                                             exp( -1 * decay * ( which(yrs == yy) - 2 ) ) ) * c_mod ) ),
           !!vart := pmin(0.999, if_else(year == 2010, 0.95*t0, #assumption in 2010
                                         ( 1 +  ( t0 / t_mod - 1 ) * 
                                             exp( -1 * decay * ( which(yrs == yy) - 2 ) ) ) * t_mod ) ) ) %>% 
    mutate(!!varc := if_else(!!inc_f == 0, 0, !!varc),
           !!vart := if_else(!!inc_f == 0, 0, !!vart) )  %>% 
    select(-year, -c0, -t0, -c_mod,-t_mod)
}

# recycling rate, 0.8 of treatment
add_recycl = function(df,yy){
  varr = rlang::sym(paste0('urban_treatment_rate.',yy) )
  df %>%
    mutate("recycling_rate.{yy}" := pmin(0.8, 0.8 * !!varr ))
}

#adding all estimation for future years
ww_proj.df = ww.df2
for (yy in yrs) {
  for (uu in UR) {
    ww_proj.df = ww_proj.df %>% left_join(
      ww_proj(ww.df2,uu,yy) )
  }
  ww_proj.df = ww_proj.df %>% left_join(
    add_recycl(ww_proj.df,yy) )
}

dat.df = dat.spdf@data %>% 
  mutate(xcord = dat_simpl.spdf$xloc,
         ycord = dat_simpl.spdf$yloc) %>% 
  left_join(ww_proj.df %>% 
              select(-all_of(vec),-country_id,-udw_raw, -usa_raw))

dat.df[is.na(dat.df)] = 0

#sanitation curve more on the right, but also urban wrt rural, not clear
# for sanitation it makes a difference if I take country means of single point
# for water access the difference is minimal

#Plotting # of people without access: Urban and rural in 2020
#re-add to dat.spdf
dat.spdf = dat.df
coordinates(dat.spdf) = ~ xcord + ycord

ww_plot = dat.spdf[c("country",'urban_pop.2020','rural_pop.2020',"urban_connection_rate.2020",
                     "rural_connection_rate.2020","urban_treatment_rate.2020",
                     "rural_treatment_rate.2020")]
ww_plot@data$urban_no_wa.2020 = ww_plot$urban_pop.2020 * (1 - ww_plot$urban_connection_rate.2020) *1e-6
ww_plot@data$rural_no_wa.2020 = ww_plot$rural_pop.2020 * (1 - ww_plot$rural_connection_rate.2020) *1e-6
ww_plot@data$urban_no_san.2020 = ww_plot$urban_pop.2020 * (1 - ww_plot$urban_treatment_rate.2020) *1e-6
ww_plot@data$rural_no_san.2020 = ww_plot$rural_pop.2020 * (1 - ww_plot$rural_treatment_rate.2020) *1e-6

totals_ww = ww_plot@data %>% summarise(urban_no_wa.2020 = sum(urban_no_wa.2020),
                                       rural_no_wa.2020 = sum(rural_no_wa.2020),
                                       urban_no_san.2020 = sum(urban_no_san.2020),
                                       rural_no_san.2020 = sum(rural_no_san.2020))

extent(ww_plot)
proj4string(ww_plot) = c("+proj=longlat +datum=WGS84 +no_defs")
empty.rs = extent(-180, 180, -90, 90)
empty.rs <- raster(empty.rs)
res(empty.rs)<- 0.25 # area is about 27*27 km
projection(empty.rs)<-CRS(proj4string(ww_plot))

rw.rs = rasterize(ww_plot,empty.rs,'rural_no_wa.2020',fun = sum)
names(rw.rs) = 'value'
# names(rw.rs) = 'Rural pop. w/o clean water access.2020 [millions]'
uw.rs = rasterize(ww_plot,empty.rs,'urban_no_wa.2020',fun = sum)
names(uw.rs) = 'value'
# names(uw.rs) = 'Urban pop. w/o clean water access.2020 [millions]'
tot_cw.rs = rw.rs + uw.rs

rs.rs = rasterize(ww_plot,empty.rs,'rural_no_san.2020',fun = sum)
names(rs.rs) = 'value'
#names(rs.rs) = 'Rural pop. w/o clean sanitation [millions]'
us.rs = rasterize(ww_plot,empty.rs,'urban_no_san.2020',fun = sum)
names(us.rs) = 'value'
#names(us.rs) = 'Urban pop. w/o clean sanitation.2020 [millions]'
tot_s.rs = rs.rs + us.rs

ww.br = brick(rw.rs,uw.rs,rs.rs,us.rs)
plot(tot_cw.rs)

# store for later
bbbb = dat.df

#rst = lapply( 1:2, function( add_SDG_constrain ){
#for( add_SDG_constrain in 1:3 )

dat.df = bbbb

scn = 'baseline'
# Minimum level of daily water demand for decent living - SSP1 manufacturing demands to incorporate expected water efficiency measures in SDG6 scenarios
if( scn %in% c('sdg6') ){

   fsc = SSP

  # Add manufacturing demands - simple approach where national values generated previously are downscaled to urban areas based on population
  mf_withdrawal.df = data.frame( read.csv( paste0(data_path,'/manufacturing_water_demand_results/national/IIASA_water_withdrawal_manufacturing_Static.csv'), stringsAsFactors = FALSE ) )
  mf_return.df = data.frame( read.csv( paste0(data_path,'/manufacturing_water_demand_results/national/IIASA_water_return_manufacturing_Static.csv'), stringsAsFactors = FALSE ) )
  mf_withdrawal.df = mf_withdrawal.df[which( as.character(mf_withdrawal.df$Scenario) == fsc & !is.na(mf_withdrawal.df$UN_Code)),]
  mf_return.df = mf_return.df[which( as.character(mf_return.df$Scenario) == fsc & !is.na(mf_return.df$UN_Code)),]

  # Downscale based on country
  dat.df = cbind( dat.df, do.call( cbind, lapply( yrs, function(yy){
    cnt = unique( as.character( dat.df$country ) )[ which( unique( as.character( dat.df$country ) ) %in% unique( as.character( mf_withdrawal.df$Country_Code ) ) ) ]
    mfpc = unlist( sapply( cnt, function(cc){ return( mf_withdrawal.df[ which( as.character( mf_withdrawal.df$Scenario ) == fsc & as.character( mf_withdrawal.df$Country_Code ) == cc ), paste('X',yy,sep='') ] / sum(dat.df[ which( dat.df$country == cc ), paste('urban_pop',yy,sep= '.') ], na.rm = TRUE ) ) } ) )
    tmp.df = data.frame( country = dat.df$country )
    tmp.df$res = NA
    for( x in cnt ){ tmp.df$res[ as.character( tmp.df$country ) == x ] = dat.df[ as.character( dat.df$country ) == x, paste('urban_pop',yy,sep= '.') ] * mfpc[x ] }
    res = data.frame( tmp.df$res )
    names(res) = paste('mf_withdrawal',yy,sep= '.')
    row.names(res) = row.names(dat.df)
    return(res) } ) ) )
  dat.df = cbind( dat.df, do.call( cbind, lapply( yrs, function(yy){
    cnt = unique( as.character( dat.df$country ) )[ which( unique( as.character( dat.df$country ) ) %in% unique( as.character( mf_return.df$Country_Code ) ) ) ]
    mfpc = unlist( sapply( cnt, function(cc){ return( mf_return.df[ which( as.character( mf_return.df$Scenario ) == fsc & as.character( mf_return.df$Country_Code ) == cc ), paste('X',yy,sep='') ] / sum(dat.df[ which( dat.df$country == cc ), paste('urban_pop',yy,sep= '.') ], na.rm = TRUE ) ) } ) )
    tmp.df = data.frame( country = dat.df$country )
    tmp.df$res = NA
    for( x in cnt ){ tmp.df$res[ as.character( tmp.df$country ) == x ] = dat.df[ as.character( dat.df$country ) == x, paste('urban_pop',yy,sep= '.') ] * mfpc[x ] }
    res = data.frame( tmp.df$res )
    names(res) = paste('mf_return',yy,sep= '.')
    row.names(res) = row.names(dat.df)
    return(res) } ) ) )

  ch = scn

  # Adjust demands in urban grid cells with less than 100 L per day and for rural cells with less than 50 L per day - only for post-2030
  urb_min_sdg = 100 / 0.8
  rur_min_sdg = 50 / 0.8
  for( yyy in yrs[ yrs >= 2030 ] )
  {

    upo = dat.df[,paste('urban_pop',yyy,sep= '.')]
    rpo = dat.df[,paste('rural_pop',yyy,sep= '.')]

    upc = dat.df[,paste('urban_per_capita_withdrawal',yyy,sep= '.')] * 1e9 / 365 # convert from mcm per year to liters per day
    rpc = dat.df[,paste('rural_per_capita_withdrawal',yyy,sep= '.')] * 1e9 / 365 # convert from mcm per year to liters per day
    upc[is.na(upc)]=0
    rpc[is.na(rpc)]=0

    udxi = density( upc[ which( upc > 0 ) ], weights = upo[ which( upc > 0 ) ] / sum( upo[ which( upc > 0 ) ] ) )
    rdxi = density( rpc[ which( rpc > 0 ) ], weights = rpo[ which( rpc > 0 ) ] / sum( rpo[ which( rpc > 0 ) ] ) )

    upc[ which( upc < urb_min_sdg & upc > 0 ) ] = urb_min_sdg
    rpc[ which( rpc < rur_min_sdg & rpc > 0 ) ] = rur_min_sdg

    udxf = density( upc[ which( upc > 0 ) ], weights = upo[ which( upc > 0 ) ] / sum( upo[ which( upc > 0 ) ] ) )
    rdxf = density( rpc[ which( rpc > 0 ) ], weights = rpo[ which( rpc > 0 ) ] / sum( rpo[ which( rpc > 0 ) ] ) )

    # pdf(paste('C:/Users/parkinso/Documents/mwdens',yyy,'.pdf',sep=''))
    # p1 = layout(matrix(c(1,2),1,2,byrow=TRUE),widths=c(0.45,0.45),heights=c(0.9,0.1))
    # plot( udxi$x * 0.8 , cumsum(udxi$y)/max(cumsum(udxi$y)), type='l', col = 'black', xlab = 'Liters per day', ylab = 'Cumulative Population Distribution', main = paste( 'Urban',yyy, sep=' - ') )
    # lines( udxf$x * 0.8, cumsum(udxf$y)/max(cumsum(udxf$y)), type='l', col = 'red' )
    # plot( rdxi$x * 0.8, cumsum(rdxi$y)/max(cumsum(rdxi$y)), type='l', col = 'black', xlab = 'Liters per day', ylab = 'Cumulative Population Distribution', main = paste( 'Rural',yyy, sep=' - ') )
    # lines( rdxf$x * 0.8, cumsum(rdxf$y)/max(cumsum(rdxf$y)), type='l', col = 'red' )
    # legend( 'bottomright', bty = 'n', legend = c('Baseline', 'SDG6'), lty = 1, col = c('black','red') )
    # dev.off()

    # Convert units to km3 per year
    dat.df[,paste('urban_per_capita_withdrawal',yyy,sep= '.')] = upc * 1e-9 * 365
    dat.df[,paste('rural_per_capita_withdrawal',yyy,sep= '.')] = rpc * 1e-9 * 365

    dat.df[,paste('urban_withdrawal',yyy,sep= '.')] = dat.df[, paste('urban_per_capita_withdrawal', yyy, sep= '.')] * dat.df[, paste('urban_pop', yyy, sep= '.')]
    dat.df[,paste('rural_withdrawal',yyy,sep= '.')] = dat.df[, paste('rural_per_capita_withdrawal', yyy, sep= '.')] * dat.df[, paste('rural_pop', yyy, sep= '.')]

      # previously sdg6_eff
      # Further end-use conservation assumed combining a 10% reduction in withdrawals due to
      # behavioral changes and 10% recycling
      fct = 0.9 * 0.9

      dat.df[,paste('urban_withdrawal',yyy,sep= '.')] = fct * dat.df[, paste('urban_withdrawal', yyy, sep= '.')]
      dat.df[,paste('urban_return',yyy,sep= '.')] = fct * dat.df[, paste('urban_return', yyy, sep= '.')]
      dat.df[,paste('rural_withdrawal',yyy,sep= '.')] = fct * dat.df[, paste('rural_withdrawal', yyy, sep= '.')]
      dat.df[,paste('rural_return',yyy,sep= '.')] = fct * dat.df[, paste('rural_return', yyy, sep= '.')]
      dat.df[,paste('mf_withdrawal',yyy,sep= '.')] = fct * dat.df[, paste('mf_withdrawal', yyy, sep= '.')]
      dat.df[,paste('mf_return',yyy,sep= '.')] = fct * dat.df[, paste('mf_return', yyy, sep= '.')]


    inds = which( unlist( dat.df[, paste('urban_return',yyy,sep= '.') ] ) > 0.92 * unlist(dat.df[, paste('urban_withdrawal', yyy, sep= '.') ] ) )
    if( length(inds)>0 ){ dat.df[ inds, paste('urban_return',yyy,sep= '.') ] = dat.df[inds, paste('urban_withdrawal', yyy, sep= '.') ] * 0.92 }
    inds = which( unlist( dat.df[, paste('rural_return',yyy,sep= '.') ] ) > 0.92 * unlist(dat.df[, paste('rural_withdrawal', yyy, sep= '.') ] ) )
    if( length(inds)>0 ){ dat.df[ inds, paste('rural_return',yyy,sep= '.') ] = dat.df[inds, paste('rural_withdrawal', yyy, sep= '.') ] * 0.92 }
    inds = which( unlist( dat.df[, paste('mf_return',yyy,sep= '.') ] ) > 0.92 * unlist(dat.df[, paste('mf_withdrawal', yyy, sep= '.') ] ) )
    if( length(inds)>0 ){ dat.df[ inds, paste('mf_return',yyy,sep= '.') ] = dat.df[inds, paste('mf_withdrawal', yyy, sep= '.') ] * 0.92 }

  }


}else{ # baseline


  # Add manufacturing demands - simple approach where national values generated previously are downscaled to urban areas based on population
  mf_withdrawal.df = data.frame( read.csv( paste0(data_path,'/manufacturing_water_demand_results/national/IIASA_water_withdrawal_manufacturing_Static.csv'), stringsAsFactors = FALSE ) )
  mf_return.df = data.frame( read.csv( paste0(data_path,'/manufacturing_water_demand_results/national/IIASA_water_return_manufacturing_Static.csv'), stringsAsFactors = FALSE ) )
  mf_withdrawal.df = mf_withdrawal.df[which( as.character(mf_withdrawal.df$Scenario) == 'SSP2' & !is.na(mf_withdrawal.df$UN_Code)),]
  mf_return.df = mf_return.df[which( as.character(mf_return.df$Scenario) == 'SSP2' & !is.na(mf_return.df$UN_Code)),]

  dat.df = cbind( dat.df, do.call( cbind, lapply( yrs, function(yy){
    cnt = unique( as.character( dat.df$country ) )[ which( unique( as.character( dat.df$country ) ) %in% unique( as.character( mf_withdrawal.df$Country_Code ) ) ) ]
    mfpc = unlist( sapply( cnt, function(cc){ return( mf_withdrawal.df[ which( as.character( mf_withdrawal.df$Scenario ) == 'SSP2' & as.character( mf_withdrawal.df$Country_Code ) == cc ), paste('X',yy,sep='') ] / sum(dat.df[ which( dat.df$country == cc ), paste('urban_pop',yy,sep= '.') ], na.rm = TRUE ) ) } ) )
    tmp.df = data.frame( country = dat.df$country )
    tmp.df$res = NA
    for( x in cnt ){ tmp.df$res[ as.character( tmp.df$country ) == x ] = dat.df[ as.character( dat.df$country ) == x, paste('urban_pop',yy,sep= '.') ] * mfpc[x ] }
    res = data.frame( tmp.df$res )
    names(res) = paste('mf_withdrawal',yy,sep= '.')
    row.names(res) = row.names(dat.df)
    return(res) } ) ) )
  dat.df = cbind( dat.df, do.call( cbind, lapply( yrs, function(yy){
    cnt = unique( as.character( dat.df$country ) )[ which( unique( as.character( dat.df$country ) ) %in% unique( as.character( mf_return.df$Country_Code ) ) ) ]
    mfpc = unlist( sapply( cnt, function(cc){ return( mf_return.df[ which( as.character( mf_return.df$Scenario ) == 'SSP2' & as.character( mf_return.df$Country_Code ) == cc ), paste('X',yy,sep='') ] / sum(dat.df[ which( dat.df$country == cc ), paste('urban_pop',yy,sep= '.') ], na.rm = TRUE ) ) } ) )
    tmp.df = data.frame( country = dat.df$country )
    tmp.df$res = NA
    for( x in cnt ){ tmp.df$res[ as.character( tmp.df$country ) == x ] = dat.df[ as.character( dat.df$country ) == x, paste('urban_pop',yy,sep= '.') ] * mfpc[x ] }
    res = data.frame( tmp.df$res )
    names(res) = paste('mf_return',yy,sep= '.')
    row.names(res) = row.names(dat.df)
    return(res) } ) ) )

  ch = scn

} # end baseline
# CHECK TILL HERE

#### format OUTPUT ####
cccc = dat.df
#one can run also simply for a country
# reg = 'ZMB'
for(reg in c('R11','R12')){
  #### Make spatial####
  dat.spdf = cccc
  coordinates(dat.spdf) = ~ xcord + ycord
  #load shapefile
  basin_by_region.spdf = readOGR('P:/ene.model/NEST/delineation/data/delineated_basins_new',
                                paste0('basins_by_region_simpl_',reg), verbose=FALSE)
  basin_by_region.spdf = gBuffer(basin_by_region.spdf, byid=TRUE, width=0.2)
  
  proj4string(dat.spdf) = basin_by_region.spdf@proj4string
  
  empty_points = SpatialPoints(coords = coordinates(dat.spdf))
  proj4string(empty_points) = proj4string(dat.spdf)
  
  inters = over(empty_points,basin_by_region.spdf)
  
  inters_cols = inters %>% select(NAME,REGION,BCU_name)
  #two alternatives
  dat.spdf@data = dat.spdf@data %>% bind_cols(inters_cols)
  print(paste0(sum(is.na(inters$BCU_name)),' points have no basin infomration, are removed'))
  #
  dat.df = dat.spdf@data
  dat.df = dat.df[!is.na(dat.df$BCU_name),]
  dat.df$region = dat.df$BCU_name
  
  ysr_full = c(yrs)
  
  #including manufacturing
  regional_urban_withdrawal.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_withdrawal', yy, sep= '.') ) ] ) , na.rm=TRUE ) + sum(unlist(dat.df[which(dat.df$region == rr ) , c(paste('mf_withdrawal', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_urban_withdrawal.df) = unique( dat.df$region )
  row.names(regional_urban_withdrawal.df) = ysr_full
  regional_urban_withdrawal.df = round( regional_urban_withdrawal.df, digits = 3 )
  
  #initialize var_list
  var_list = list('regional_urban_withdrawal' = regional_urban_withdrawal.df)

  # urban return flows
  regional_urban_return.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_return', yy, sep= '.') ) ] ) , na.rm=TRUE ) + sum(unlist(dat.df[which(dat.df$region == rr ) , c(paste('mf_return', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_urban_return.df) = unique( dat.df$region )
  row.names(regional_urban_return.df) = ysr_full
  regional_urban_return.df = round( regional_urban_return.df, digits = 3 )
  var_list = append(var_list,list('regional_urban_return' = regional_urban_return.df) )

  # without manufacturing
  regional_urban_withdrawal2.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_withdrawal', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_urban_withdrawal2.df) = unique( dat.df$region )
  row.names(regional_urban_withdrawal2.df) = ysr_full
  regional_urban_withdrawal2.df = round( regional_urban_withdrawal2.df, digits = 3 )
  var_list = append(var_list,list('regional_urban_withdrawal2' = regional_urban_withdrawal2.df))

  regional_urban_return2.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_return', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_urban_return2.df) = unique( dat.df$region )
  row.names(regional_urban_return2.df) = ysr_full
  regional_urban_return2.df = round( regional_urban_return2.df, digits = 3 )
  var_list = append(var_list,list('regional_urban_return2' = regional_urban_return2.df))

  # manufacturing withdrawals
  regional_manufacturing_withdrawal.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'mf_withdrawal', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_manufacturing_withdrawal.df) = unique( dat.df$region )
  row.names(regional_manufacturing_withdrawal.df) = ysr_full
  regional_manufacturing_withdrawal.df = round( regional_manufacturing_withdrawal.df, digits = 3 )
  var_list = append(var_list,list('regional_manufacturing_withdrawal' = regional_manufacturing_withdrawal.df))

  # manufacturing return flows
  regional_manufacturing_return.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){ sum(unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'mf_return', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_manufacturing_return.df) = unique( dat.df$region )
  row.names(regional_manufacturing_return.df) = ysr_full
  regional_manufacturing_return.df = round( regional_manufacturing_return.df, digits = 3 )
  var_list = append(var_list,list('regional_manufacturing_return' = regional_manufacturing_return.df))

  # urban connection rate
  regional_urban_connection_rate.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){ sum(c( unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_pop', yy, sep= '.') ) ] )  * unlist(dat.df[which(dat.df$region == rr ) , c(paste('urban_connection_rate', yy, sep= '.') ) ] ) ) , na.rm=TRUE ) / sum(c(unlist(dat.df[which(dat.df$region == rr ) , c(paste('urban_pop', yy, sep= '.') ) ] ) ) , na.rm = TRUE ) } ) } ) ) )
  names(regional_urban_connection_rate.df) = unique( dat.df$region )
  row.names(regional_urban_connection_rate.df) = ysr_full
  regional_urban_connection_rate.df = round( regional_urban_connection_rate.df, digits = 3 )
  var_list = append(var_list,list('regional_urban_connection_rate' = regional_urban_connection_rate.df))

  #urban treatment rate
  regional_urban_treatment_rate.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum( c( unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_pop', yy, sep='.' ) ) ] )  * unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_treatment_rate', yy, sep='.' ) ) ] ) ) , na.rm=TRUE ) / sum( c( unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_pop', yy, sep='.' ) ) ] ) ) , na.rm = TRUE ) } ) } ) ) )
  names(regional_urban_treatment_rate.df ) = unique( dat.df$region )
  row.names(regional_urban_treatment_rate.df) = ysr_full
  regional_urban_treatment_rate.df = round( regional_urban_treatment_rate.df, digits = 3 )
  var_list = append(var_list,list('regional_urban_treatment_rate' = regional_urban_treatment_rate.df))
  
  ## COMMENTED FOR NOW
  # regional_urban_desalination_rate.df =  data.frame( round(  do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){ sum( unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'desalinated', yy, sep='.' ) ) ] ) , na.rm=TRUE ) / sum( unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'urban_withdrawal', yy, sep='.' ) ) ] ) + unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'mf_withdrawal', yy, sep='.' ) ) ] ) , na.rm=TRUE ) } ) } ) ), digits = 3 ) )
  # names(regional_urban_desalination_rate.df) = unique( dat.df$region )
  # row.names(regional_urban_desalination_rate.df) = ysr_full
  # regional_urban_desalination_rate.df = round( regional_urban_desalination_rate.df, digits = 3 )
  # regional_urban_desalination_rate.df[ regional_urban_desalination_rate.df < 0.005 ] = 0.005
  # var_list = append(var_list,list('regional_urban_desalination_rate' = regional_urban_desalination_rate.df))
  # # END COMMENTED PART

  # urban recycling rate
  regional_urban_recycling_rate.df = data.frame( round(do.call( cbind, lapply( unique( dat.df$region ), function(rr){ 
    sapply( ysr_full, function(yy){ 
      sum( (unlist(dat.df[which(dat.df$region == rr ) , c(paste('urban_withdrawal', yy, sep= '.') ) ] ) + 
              unlist(dat.df[which(dat.df$region == rr ) , c(paste('mf_withdrawal', yy, sep= '.') ) ] )) * 
             unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'recycling_rate', yy, sep= '.') ) ] ) , na.rm=TRUE ) / 
        sum(unlist(dat.df[which(dat.df$region == rr ) , c(paste('urban_withdrawal', yy, sep= '.') ) ] ) + 
              unlist(dat.df[which(dat.df$region == rr ) , c(paste('mf_withdrawal', yy, sep= '.') ) ] ) , na.rm=TRUE )
      } ) } ) ), digits = 3 ) )
  names(regional_urban_recycling_rate.df) = unique( dat.df$region )
  row.names(regional_urban_recycling_rate.df) = ysr_full
  regional_urban_recycling_rate.df = round( regional_urban_recycling_rate.df, digits = 3 )
  regional_urban_recycling_rate.df[ regional_urban_recycling_rate.df < 0.005 ] = 0.005
  var_list = append(var_list,list( 'regional_urban_recycling_rate' = regional_urban_recycling_rate.df))

  # rural connection rate
  regional_rural_connection_rate.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(c( unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'rural_pop', yy, sep= '.') ) ] )  * unlist(dat.df[which(dat.df$region == rr ) , c(paste('rural_connection_rate', yy, sep= '.') ) ] ) ) , na.rm=TRUE ) / sum(c(unlist(dat.df[which(dat.df$region == rr ) , c(paste('rural_pop', yy, sep= '.') ) ] ) ) , na.rm = TRUE ) } ) } ) ) )
  names(regional_rural_connection_rate.df) = unique( dat.df$region )
  row.names(regional_rural_connection_rate.df) = ysr_full
  regional_rural_connection_rate.df = round( regional_rural_connection_rate.df, digits = 3 )
  var_list = append(var_list,list('regional_rural_connection_rate' = regional_rural_connection_rate.df))

  # rural treatment rates
  regional_rural_treatment_rate.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(c( unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'rural_pop', yy, sep= '.') ) ] )  * unlist(dat.df[which(dat.df$region == rr ) , c(paste('rural_treatment_rate', yy, sep= '.') ) ] ) ) , na.rm=TRUE ) / sum(c(unlist(dat.df[which(dat.df$region == rr ) , c(paste('rural_pop', yy, sep= '.') ) ] ) ) , na.rm = TRUE ) } ) } ) ) )
  names(regional_rural_treatment_rate.df) = unique( dat.df$region )
  row.names(regional_rural_treatment_rate.df) = ysr_full
  regional_rural_treatment_rate.df = round( regional_rural_treatment_rate.df, digits = 3 )
  var_list = append(var_list,list('regional_rural_treatment_rate' = regional_rural_treatment_rate.df))

  # rural withdrawals
  regional_rural_withdrawal.df = data.frame( do.call( cbind, lapply( unique( dat.df$region ), function(rr){ sapply( ysr_full, function(yy){  sum(unlist( dat.df[ which( dat.df$region == rr ) , c( paste( 'rural_withdrawal', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_rural_withdrawal.df) = unique( dat.df$region )
  row.names(regional_rural_withdrawal.df) = ysr_full
  regional_rural_withdrawal.df = round( regional_rural_withdrawal.df, digits = 3 )
  var_list = append(var_list,list('regional_rural_withdrawal' = regional_rural_withdrawal.df))

  # return flows, only SDG6
  regional_rural_return.df = data.frame(
    do.call( cbind, lapply( unique( dat.df$region ), function(rr){
      sapply( ysr_full, function(yy){
        sum(unlist( dat.df[ which( dat.df$region == rr ) ,
                             c( paste( 'rural_return', yy, sep= '.') ) ] ) , na.rm=TRUE ) } ) } ) ) )
  names(regional_rural_return.df) = unique( dat.df$region )
  row.names(regional_rural_return.df) = ysr_full
  regional_rural_return.df = round( regional_rural_return.df, digits = 3 )
  var_list = append(var_list,list('regional_rural_return' = regional_rural_return.df))

  # ADDING FINAL TIME STEPS AND SAVE csv #
  rates = names(var_list)[grepl('_rate',names(var_list))]
  for (v in names(var_list)){
    df = as.data.frame(var_list[v][[1]])
    df[is.na(df)] = 0
    n=ncol(df)+1
    
    for_lm = df %>%
      mutate(year = row.names(.)) %>%
      select(year,everything()) %>%
      filter(year >= 2060) %>%
      gather(key = 'region',value = 'value',2:n) %>%
      group_by(region) %>%
      mutate(int = lm(value ~ year)$coefficients[1],
             coef = lm(value ~ year)$coefficients[2]) %>%
      ungroup()
    # add 2100, 2110
    new_vals = for_lm %>% select(-year,-value) %>%
      distinct() %>%
      mutate(`2100` := int + (2100-2060)/10 * coef ,
             `2110` := int + (2110-2060)/10 * coef  ) %>%
      mutate(`2100` =  pmax(0,`2100` ),
             `2110` = pmax(0,`2110`) ) 
    
    if (v %in% rates) {
      new_vals = new_vals %>% 
        mutate(`2100` =  pmin(0.99,`2100` ),
               `2110` = pmin(0.99,`2110`)) %>% 
        gather(key = year, value = 'value',`2100`,`2110`)
    }else{ new_vals = new_vals %>% 
      gather(key = year, value = 'value',`2100`,`2110`)}
    
    # add back to df
    final_df = df %>% bind_rows(
      new_vals %>% select(year,region,value) %>%
        spread(region,value) %>%
        tibble::column_to_rownames(var = 'year')
    )
  # Write in forlders according to region definition
    write.csv( final_df,
               paste0( data_path, '/water_demands/harmonized/',reg,'/ssp',ssp,'_',
                      v,'_', ch, '.csv' ), row.names = TRUE )

  }

} # for R11,R12

# Desalination
rm(list = ls())
require(reshape)
require(rgdal)
require(raster)
require(rgeos)
require(countrycode)
require(RCurl)
require(xlsx)

require(maptools)
require(ncdf4)

library(broom)
library(readstata13)
library(sandwich)
library(lmtest)
library(zoo)
library(readxl)
library(corrplot)
library(plm)
library(car)
# library(gghighlight)

library(tidyverse)
# library(caret)

# here we put together the data processing scripts that
# 1. determine historical capacity (from oder add_Water_infractructure.R from Simon)
# 2. set future base desalination trends
# 3. set upperbound for desalination expansion/speed of growth

model_years = c(1990,1995,2000,2005,2010,2015)
#define region

#### not needed####
# Load in the cleaned desal database from Hanasaki et al 2016 and add MESSAGE regions
reg.spdf = readOGR('P:/ene.model/data/desalination','REGION_dissolved',verbose=FALSE) # old
global_desal.spdf = spTransform( readOGR('P:/ene.model/NEST/desalination/Hanasaki_et_al_2015','global_desalination_plants'), crs(reg.spdf) )
global_desal.spdf@data$region = over(global_desal.spdf,reg.spdf[,which(names(reg.spdf) == 'REGION')])$REGION
global_desal.spdf = global_desal.spdf[ -1*which( is.na(global_desal.spdf@data$region) ), ]
global_desal.spdf@data$msg_vintage = sapply( global_desal.spdf@data$online, function(x){ as.numeric( model_years[ which.min( ( as.numeric( model_years ) - x )^2 ) ] ) } )
global_desal.spdf@data$technology_2 = sapply( global_desal.spdf@data$technology, function(x){ if( grepl('MSF',x)|grepl('MED',x) ){ return('distillation') }else{ return('membrane') }} )

# From : Chart 1.1 in 'Executive Summary Desalination Technology Markets Global Demand Drivers, Technology Issues, Competitive Landscape, and Market Forecasts'
# Global desalination capacity in 2010 was approx. 24 km3 / year
global_desal.spdf@data$m3_per_day = global_desal.spdf@data$m3_per_day  * ( 24  / ( sum( global_desal.spdf@data$m3_per_day ) * 365 / 1e9 ) )

region = unique(global_desal.spdf$region)
# Match to message vintaging and regions, km3/years
historical_desal_capacity.list = lapply( c('membrane','distillation'), function(tt){
  temp = data.frame( do.call(cbind, lapply( region, function(reg){ sapply( unique(global_desal.spdf@data$msg_vintage)[
    order(unique(global_desal.spdf@data$msg_vintage))], function(y){
      (365/1e9) * max( 0,  sum( global_desal.spdf@data$m3_per_day[
        which( global_desal.spdf@data$msg_vintage == y & global_desal.spdf@data$region == reg &
                 global_desal.spdf@data$technology_2 == tt ) ] , na.rm=TRUE ), na.rm=TRUE ) } ) } ) ) )
  names(temp) = region
  row.names(temp) = unique(global_desal.spdf@data$msg_vintage)[order(unique(global_desal.spdf@data$msg_vintage))]
  return(temp)
} )
names(historical_desal_capacity.list) = c('membrane','distillation')

#### from here ####

#summarise for regression
global_desal.csv = read.csv('P:/ene.model/NEST/desalination/Hanasaki_et_al_2015/desal_data_Hanasaki_et_al_2015.csv')

desal_data.df = global_desal.csv
# clean up names
names(desal_data.df) = c("country","location","m3_per_day","technology","water_type","online","user","price","lat","lon")
desal_data.df$country = as.character(desal_data.df$country)
desal_data.df$location = as.character(desal_data.df$location)
desal_data.df$technology = as.character(desal_data.df$technology)
desal_data.df$water_type = as.character(desal_data.df$water_type)
desal_data.df$user = as.character(desal_data.df$user)
desal_data.df$price = as.character(desal_data.df$price)
desal_data.df$m3_per_day = gsub(",", "", desal_data.df$m3_per_day)
desal_data.df$m3_per_day = as.numeric(desal_data.df$m3_per_day)
desal_data.df$online = as.numeric(desal_data.df$online)
desal_data.df$lat = as.numeric(desal_data.df$lat)
desal_data.df$lon = as.numeric(desal_data.df$lon)
temp1 = unique(desal_data.df$user)
temp2 = c('municipal','industry','power','tourism','irrigation','military')
for (i in 1:length(temp1))
{
  desal_data.df$user[desal_data.df$user == temp1[i]] = temp2[i]
}
temp1 = unique(desal_data.df$water_type)
temp2 = c('seawater','brine')
for (i in 1:length(temp1))
{
  desal_data.df$water_type[desal_data.df$water_type == temp1[i]] = temp2[i]
}
head(desal_data.df)

map_iso3 = data.frame(country = unique(desal_data.df$country),
                      iso3 = countrycode(unique(desal_data.df$country),
                                         origin = 'country.name',
                                         destination = 'iso3c' ))
desal_data.df = desal_data.df %>% left_join(map_iso3)

#### DESALDATA direclty form database and see if there is more data than from Hanasaki et al 2016 ####
desaldata.csv = read.csv('P:/ene.model/NEST/desalination/DESALCAPACITYDATA/DesalData-2016-06-15.csv')

desaldata.df = desaldata.csv %>%
  select(Country,Location,Capacity..m3.d.,Technology,Feedwater,Online.date,Customer.type,EPC.price,Plant.status,Latitude,Longitude)

# clean up names
names(desaldata.df) = c("country","location","m3_per_day","technology","water_type","online","user","price","status","lat","lon")
desaldata.df$country = as.character(desaldata.df$country)
desaldata.df$location = as.character(desaldata.df$location)
desaldata.df$technology = as.character(desaldata.df$technology)
desaldata.df$water_type = as.character(desaldata.df$water_type)
desaldata.df$user = as.character(desaldata.df$user)
desaldata.df$price = as.character(desaldata.df$price)
desaldata.df$m3_per_day = gsub(",", "", desaldata.df$m3_per_day)
desaldata.df$m3_per_day = as.numeric(desaldata.df$m3_per_day)
desaldata.df$online = as.numeric(desaldata.df$online)
desaldata.df$status = as.character(desaldata.df$status)
desaldata.df$lat = as.numeric(desaldata.df$lat)
desaldata.df$lon = as.numeric(desaldata.df$lon)
temp1 = unique(desaldata.df$user)
temp2 = c('municipal','industry','power','tourism','irrigation','military')
for (i in 1:length(temp1))
{
  desaldata.df$user[desaldata.df$user == temp1[i]] = temp2[i]
}
temp1 = unique(desaldata.df$water_type)
temp2 = c('seawater','brine')
for (i in 1:length(temp1))
{
  desaldata.df$water_type[desaldata.df$water_type == temp1[i]] = temp2[i]
}
# status online, or ofline
desaldata.df = desaldata.df %>% mutate(status = if_else(grepl('Offline|Cancelled',status), 'offline','online') )
head(desaldata.df)
write.csv(desaldata.df,'P:/ene.model/NEST/desalination/DESALCAPACITYDATA2016_clean.csv')
# online plants for historical capacity
desaldata_online.df = desaldata.df %>% filter(status == 'online')
write.csv(desaldata_online.df,'P:/ene.model/NEST/desalination/DESALCAPACITYDATA2016_current_online.csv')

desaldata.df = desaldata.df %>% select(-status)
map_iso3 = data.frame(country = unique(desaldata.df$country),
                      iso3 = countrycode(unique(desaldata.df$country),
                                         origin = 'country.name',
                                         destination = 'iso3c' ))
desaldata.df = desaldata.df %>% left_join(map_iso3)

# m3_day yearly new capacity
desal_new_cap.df = desal_data.df %>%
  rename(year = online) %>%
  group_by(iso3,year) %>%
  summarise(desal_cap = sum(m3_per_day)) %>% ungroup() %>%
  group_by(iso3) %>%
  mutate(cum_desal = cumsum(desal_cap)) %>% ungroup()

#from desalCAPACITYDATA database
desal_new_cap2.df = desaldata.df %>%
  rename(year = online) %>% filter(!is.na(year),!is.na(m3_per_day)) %>%
  group_by(iso3,year) %>%
  summarise(desal_cap = sum(m3_per_day)) %>% ungroup() %>%
  group_by(iso3) %>%
  mutate(cum_desal = cumsum(desal_cap)) %>% ungroup()

desal_new_cap_glb.df = desal_new_cap2.df %>% group_by(year) %>% 
  summarise(desal_cap = sum(desal_cap),
            cum_desal = sum(cum_desal)) %>% ungroup() %>% 
  mutate(cum_desal2 = cumsum(desal_cap)) %>% 
  gather(key = "cum_type",value = "value",cum_desal,cum_desal2)

ggplot(desal_new_cap_glb.df)+
  geom_line(aes(x = year,y = value, color = cum_type))

#comparison
desal_comp = desal_new_cap.df %>%
  left_join(desal_new_cap2.df  %>%
              rename(desal2 = desal_cap,
                     cumsum2 = cum_desal)) %>%
  select(iso3,year,desal_cap,desal2,cum_desal,cumsum2) %>%
  group_by(iso3) %>%
  mutate(max_cumacp1 = max(cum_desal),
         max_cumcap2 = max(cumsum2)) %>% ungroup() %>%
  filter( (cum_desal == max_cumacp1),
          cum_desal > 1000000)

# it seems that the NA in the DESALCAPACITYDATA are included in other years in Hanasaki et al 2016
# moreover DESALCAPACITYDATA has longer historical than Hanasaki et al 2016
# Hanasaki et al 2016 summarizes some histircal data in later starting years
desal_new_cap3.df = desal_new_cap2.df %>% ungroup()

write.csv(desal_new_cap3.df,'P:/ene.model/NEST/desalination/DESALCAPACITYDATA2016_aggregated.csv')
# highest
quantiles = desal_new_cap3.df %>% group_by(iso3) %>%
  filter(cum_desal == max(cum_desal))
quantiles = quantiles %>%
  mutate(quant = if_else(cum_desal <= quantile(quantiles$cum_desal, 0.33), 'q3_3',
                         if_else(quantile(quantiles$cum_desal, 0.33) < cum_desal & cum_desal <= quantile(quantiles$cum_desal, 0.66), 'q2_3',
                                 'q1_3'))) %>%
  select(iso3,quant) %>% drop_na()

# plot to see if lines can be approssimates with linear models
ggplot(desal_new_cap3.df %>% left_join(quantiles) %>% filter(quant == 'q1_3'))+
  geom_line(aes(x = year,y = cum_desal))+
  facet_wrap(~iso3)+theme_bw()
ggplot(desal_new_cap3.df %>% left_join(quantiles) %>% filter(quant == 'q2_3'))+
  geom_line(aes(x = year,y = cum_desal))+
  facet_wrap(~iso3)+theme_bw()
ggplot(desal_new_cap3.df %>% left_join(quantiles) %>% filter(quant == 'q3_3'))+
  geom_line(aes(x = year,y = cum_desal))+
  facet_wrap(~iso3)+theme_bw()
# veryfy normal distribution assumption
hist(desal_new_cap3.df$desal_cap)
hist(desal_new_cap3.df$cum_desal)
# log
hist(log(desal_new_cap3.df$desal_cap) )
#it does not look very normal, it is right-skewed
hist(log(desal_new_cap3.df$cum_desal) )
# using cumulative capacity it has a normal shape

# load other variables for regression model
# GDP WB 2021 data , it has long history wrt to what Marina used
# change to NAVIGATE updates
gdp = read.csv('P:/ene.model/NEST/GDP/WB_GDP_2021/GDP_country_cleaned.csv') %>%
  gather(key = 'year',value = 'gdp',5:65) %>% select(iso3,year,gdp) %>%
  mutate(year = as.numeric(gsub('X','',year)))

gdp_historical<-read.csv("P:/ene.model/NEST/governance/governance_2021/input/navigate_ssp.csv") %>%
  filter(scenario=="WDI_2021", variable=="gdppc") %>%
  rename(iso3=region) %>%
  select(-c(scenario, variable)) %>%
  pivot_longer(!iso3, names_to = "Year", values_to = "gdp") %>%
  mutate(year = as.numeric(gsub('X','',Year))) %>%
  filter(year<2020) %>%
  select(iso3,year,gdp)

gdp_new_hist_proj = read.csv('P:/ene.model/NEST/governance/governance_2021/input/gdp_full_WB_NAVIGATE.csv')
gdp_new = gdp_new_hist_proj %>% select(iso3c,year,gdppc) %>%
  rename(iso3 = iso3c, gdp = gdppc) %>% drop_na()

hist(gdp$gdp)
hist(gdp_historical$gdp)
hist(log(gdp$gdp) )
hist(log(gdp_historical$gdp) )
hist(gdp_new$gdp)
hist(log(gdp_new$gdp))
# log has a better distribution

# Worldwide Governance Indicators - updates Kaufmann, Kraay & Mastruzzi (2021)
# The values of indicators span a range from -2.5 to 2.5, here they were
# transformed to fall in the 0 to 1 range

# Function to standardize the values from 0 to 1
range01 <- function(x){(x - min(x, na.rm = T))/(max(x, na.rm = T) - min(x, na.rm = T))}

wgi <- read.dta13('P:/ene.model/NEST/governance/wgidataset.dta') %>%
  select(code, countryname, year, contains('e'), -ges, -gen, -ger, -gel, -geu) %>%
  rename(voic.ac = vae,
         pol.stab = pve,
         gov.eff = gee,
         reg.qual = rqe,
         ru.law = rle,
         corr.cont = cce,
         countrycode = code) %>%
  gather(var, value, -countrycode, -countryname, -year) %>%
  group_by(var) %>%
  mutate(value = range01(value)) %>%
  ungroup() %>%
  mutate(year = as.integer(year)) %>%
  spread(var, value) %>%
  mutate(governance = rowMeans(select(., voic.ac,
                                      pol.stab, gov.eff, reg.qual, ru.law, corr.cont))) %>%  # # Governance variable as the arithmetic average of the six components of WGI) %>%
  select(-countryname)

gov = wgi %>% select(countrycode,year,governance)
names(gov) = c('iso3','year','gov')
names(wgi) = c('iso3','year',"corr.cont","gov.eff","pol.stab","reg.qual","ru.law","voic.ac",'gov')

# other from Elina
gov_eff<- read.csv("P:/ene.model/NEST/governance/governance_2021/input/governance_2021.csv") %>%
  mutate(gov_norm=range01(gee)) %>%
  select(countryname, year, gov_norm) %>%
  arrange(countryname, year) %>%
  mutate(iso3=countrycode(countryname, "country.name", "iso3c")) %>%
  select(iso3,year,gov_norm)

gov_eff<- read.csv("P:/ene.model/NEST/governance/governance_2021/input/qog_2021.csv") %>%
  mutate(gov_norm=range01(icrg_qog)) %>%
  select(ccodealp, year, gov_norm) %>%
  arrange(ccodealp, year) %>%
  mutate(iso3=ccodealp) %>%
  select(iso3,year,gov_norm) %>% drop_na()

hist(gov$gov)
hist(gov_eff$gov_norm)
# without log, it has a normal distribution

# WSI from Ed
wsi_hist = read.xlsx('P:/ene.model/data/Water/water_stress_cc/ISO_water_stress/wsi_tables_hist_new.xlsx',
                     sheetIndex = 1)

wsi.df = wsi_hist %>% gather(key = year, value = wsi , 3:length(wsi_hist)) %>%
  filter(!grepl('_bin',year)) %>%
  mutate(year = as.numeric(gsub('X','',year)),
         wsi = round(as.numeric(wsi),digits = 3)) %>%
  rename(iso3 = ISO) %>%
  select(iso3,year,wsi)
#very high values

hist(wsi.df$wsi)
hist(log(wsi.df$wsi))
#use log
library(WDI)
wsi_wb <- WDI(country = "all",
                     indicator = c('water_stress'="ER.H2O.FWST.ZS"),
                     start = 1960,end = 2020,extra = TRUE) %>%
  as_tibble() %>%
  filter(region!="Aggregates")
wsi_wb = wsi_wb %>% drop_na()
# probably notusing it, weird values

# presence of coast # of gridcels
# it would be nice to use historical trends of population living close to the coast
coast = read.csv('P:/ene.model/NEST/desalination/coast.csv')
names(coast) = c('iso3','coast')

hist(coast$coast)
# skewed, take log
hist(log(coast$coast))

# use all log variables, except from gov
# what about NA, how to handle?
master = desal_new_cap3.df %>% select(-cum_desal) %>%
  full_join(gdp_historical) %>%  # add gdp
  mutate(desal_cap = if_else(is.na(desal_cap), 0 ,desal_cap)) %>%
  # calculate cum capacity with in na after merging
  #re-aggregate desalination capacity
  arrange(year, .by_group = T) %>% ungroup() %>% group_by(iso3) %>%
  mutate(cum_desal = cumsum(desal_cap)) %>% ungroup() %>%
  # remove gdp na
  filter(!is.na(gdp)) %>%
  #retail only countries with desaliantion
  filter(iso3 %in% unique(desal_new_cap3.df$iso3)) %>%
  left_join(gov_eff) %>%
  left_join(wgi ) %>%
  left_join(coast) %>% filter(!is.na(coast)) %>%
  left_join(wsi.df) %>%
  ungroup() %>% group_by(iso3) %>%
  mutate(wsi = as.numeric(if_else(is.na(wsi), stats::quantile(wsi,0.75,na.rm = T), wsi)),
         gov_norm = as.numeric(if_else(year < 1984, stats::quantile(gov_norm,0.25,na.rm = T), gov_norm)),
         gov = as.numeric(if_else(year < 2004, stats::quantile(gov,0.25,na.rm = T), gov)),
         # corr.cont = as.numeric(if_else(year < 1996, stats::quantile(corr.cont,0.25,na.rm = T), corr.cont)),
         # gov.eff = as.numeric(if_else(year < 1996, stats::quantile(gov.eff,0.25,na.rm = T), gov.eff)),
         # pol.stab = as.numeric(if_else(year < 1996, stats::quantile(pol.stab,0.25,na.rm = T), pol.stab)),
         # ru.law = as.numeric(if_else(year < 1996, stats::quantile(ru.law,0.25,na.rm = T), ru.law)),
         # voic.ac = as.numeric(if_else(year < 1996, stats::quantile(voic.ac,0.25,na.rm = T), voic.ac))
         ) %>%
  ungroup() %>%
  mutate(log_desal = log(cum_desal),
         log_gdp = log(gdp),
         log_coast = log(coast),
         log_wsi = log(wsi)) %>%
  # filter out -inf, all val before first desal plant
  filter(!is.infinite(log_desal),!is.infinite(log_wsi)) %>%
  # select(iso3,year,log_desal,log_gdp,gov.eff,pol.stab,reg.qual,ru.law,voic.ac,gov_norm,log_wsi,log_coast)
  select(iso3,year,log_desal,log_gdp,gov_norm,log_wsi,log_coast)

master = master %>% rename(gov = gov_norm)
#### ANALYSIS ###
# Explore correlations between the variables in the dataset
cor.exp <- master %>%
  select(log_desal, log_gdp, gov,log_wsi, log_coast) %>%
  # select(log_desal, log_gdp, gov.eff, pol.stab, reg.qual, ru.law, voic.ac, gov_norm,log_wsi, log_coast) %>%
  drop_na() %>%
  cor()

corrplot(cor.exp, method = 'number',type = 'upper')

# Split the data into training and test set
data(mtcars)

## 75% of the sample size
smp_size <- floor(0.75 * nrow(master))

## set the seed to make your partition reproducible
set.seed(123)
train_ind <- sample(seq_len(nrow(master)), size = smp_size)

train.data <- master[train_ind, ]
test.data <- master[-train_ind, ]

#### simple model #### checking multicollinearity
# lm1 <- lm(log_desal ~ log_gdp + pol.stab + gov.eff + log_wsi + log_coast, data = train.data)
lm1 <- lm(log_desal ~ log_gdp + gov + log_wsi + log_coast, data = master)
summary(lm1)
# multicolinearity
# The smallest possible value of VIF is one (absence of multicollinearity).
# As a rule of thumb, a VIF value that exceeds 5 or 10 indicates a problematic amount of collinearity (James et al. 2014).
vif(lm1)
# remove gov.eff,ru.law,reg.qual  highest value

predictions = lm1 %>% predict(test.data)
RMSE(predictions, test.data$log_desal)
R2(predictions, test.data$log_desal)
# plot prediction
pred1 = test.data %>% bind_cols(prediction = predictions)

ggplot(pred1)+
  geom_point(aes(x = log_desal,y = prediction))+
  geom_abline()+
  scale_x_continuous(limits = c(0,20))+
  scale_y_continuous(limits = c(0,20))+
  xlab('log desal cap')+ylab('predictions')

#### fixed effect test ####
# 1) way
# lm2 <- lm(log_desal ~ log_gdp + pol.stab + gov.eff + log_wsi + log_coast + factor(iso3) -1, data = master)
# lm2 <- lm(log_desal ~ log_gdp + gov + log_wsi + log_coast + factor(iso3) -1, data = master)
# summary(lm2)
# 
# predictions2 = lm2 %>% predict()
# # remove countries that do not have enough data
# # BHS, HKG, MLT, PSE
# test.data2 = test.data %>% filter(!iso3 %in% c('BHS','HKG','MLT','PSE' ))
# predictions2 = lm2 %>% predict(test.data2)
# pred2 = test.data2 %>% bind_cols(prediction = predictions2)
# 
# ggplot(pred2)+
#   geom_point(aes(x = log_desal,y = prediction, color = iso3))+
#   geom_abline()+
#   scale_x_continuous(limits = c(0,20))+
#   scale_y_continuous(limits = c(0,20))+
#   xlab('log desal cap')+ylab('predictions')

# 2) way, with plm
lm3 <- plm(log_desal ~ log_gdp + gov + log_wsi + log_coast,
           data = master,
           index = c("iso3"),
           model = "within",
           effect = 'individual'
           )
summary(lm3)
summary(fixef(lm3))

pred3 = master %>%
  group_by(iso3) %>%
  mutate(y_mean = mean(log_desal)) %>% ungroup() %>%
  mutate(pred = predict(lm3)  + y_mean) # this predict only work on the train.data, canno apply to other data

ggplot(pred3)+
  geom_point(aes(x = log_desal, y = pred, color = iso3))+
  geom_abline()+
  scale_x_continuous(limits = c(0,20))+
  scale_y_continuous(limits = c(0,20))+
  xlab('log desal cap')+ylab('predictions')+theme_bw()

# Ftest. The null is that no time-fixed effects are needed
# maybe not needed, it was for testing time effect
pFtest(lm3, lm1)
plmtest(lm3, c("time"), type=("bp"))

# store models
# manually select model names
model_names = c("lm1",'lm2',"lm3")

# create a list based on models names provided
list_models = lapply(model_names, get)
names(list_models) = model_names
summary(list_models[['lm2']])

library(rlist)
list.save(list_models, 'P:/ene.model/NEST/desalination/regression_models_lm_plm.rdata')
# test load
tes = list.load(file="P:/ene.model/NEST/desalination/regression_models_lm_plm.RData")

# print summary using robust standard errors
coeftest(lm3, vcov. = vcovHC, type = "HC1")

#### TEST and COMPARE ####

get_estimate = function(es,var){
  c = es %>%
    filter(term == var) %>%
    select(estimate)
  return(c)
}

adjust_fe = function(fe){

  years <- c(year = seq(1995, 2100, 1))

  cntry.fe <-fe %>%
    merge(years, all.y = T) %>%
    dplyr::rename(year = y) %>% drop_na()
  # mutate(fe=abs(fe))

  # Country fixed effects: they are expected to converge to the 75th percentile of the present-day distribution,
  # in years in the future changing by the SSPs. We follow the approach of Crespo Cuaresma (2017),
  # and let the fixed effects converge for SSP1: 2130, SSP2:2250, SSP3: No convergence, SSP4: 2250, SSP5: 2180
  #adjust for the year 2020 as the base

  #The convergence rates for SSP2 and SSP4 are the same

  conv.rates <- data.frame(years = c(110, 230, 3000, 230, 160),
                           scenario = c('SSP1', 'SSP2', 'SSP3', 'SSP4', 'SSP5'))
  target <- quantile(cntry.fe$fe, 0.50)
  if (target > 0){
    max.fe <- max(cntry.fe$fe)
    } else {
    max.fe <- min(cntry.fe$fe)
    }

  #Calculated decreasing rates for each SSP

  ssps<-conv.rates %>%
    mutate(r=-log(target/max.fe)/years) %>%
    select(-years)

  ssps<- merge(ssps, years, all.y = T) %>%
    dplyr::rename(year=y)

  fe_adjusted<-merge(cntry.fe, ssps, by=c("year"))

  fe_adjusted<-fe_adjusted %>%
    filter(year>2019) %>%
    group_by(iso3, scenario) %>%
    mutate(fe_adj=fe) %>%
    mutate(fe_adj=ifelse(abs(fe)>abs(target), fe*(1+r)^(2021-year), fe_adj)) %>%
    # mutate(fe_adj=-fe_adj) %>%
    # rename(Year=year)
  return(fe_adjusted)
}

#lm2
lm2_es <- tidy(lm2)

c1l2 <- get_estimate(lm2_es,'log_gdp')$estimate
# c2l2  <- get_estimate(lm2_es,'pol.stab')$estimate
c3l2 <- get_estimate(lm2_es,'gov')$estimate
c4l2 <- get_estimate(lm2_es,'log_wsi')$estimate
c5l2 <- get_estimate(lm2_es,'log_coast')$estimate

cntry.fe2 <- lm2_es %>%
  filter(grepl('factor',term)) %>%
  dplyr::rename(iso3 = term,fe = estimate) %>%
  mutate(iso3 = gsub('[factor(iso3)]','',iso3)) %>%
  select(iso3,fe)

fe2 = adjust_fe(cntry.fe2)

#lm3
lm3_es <- tidy(lm3)

c1l3 <- get_estimate(lm3_es,'log_gdp')$estimate
# c2l3  <- get_estimate(lm3_es,'pol.stab')$estimate
c3l3 <- get_estimate(lm3_es,'gov')$estimate
c4l3 <- get_estimate(lm3_es,'log_wsi')$estimate
# c5l3 <- get_estimate(lm3_es,'log_coast')$estimate

#Calculation country fixed effects

cntry.fe3 <- fixef(lm3) %>%
  as.data.frame() %>%
  rownames_to_column("iso3") %>%
  dplyr::rename(fe = ".")

fe3 = adjust_fe(cntry.fe3)

# plot
fe2 %>%
  filter(iso3 == "CHN") %>%
  filter(scenario!="SSP4") %>%
  ggplot(aes(x = year, y = fe_adj, color = scenario)) +
  geom_line(size = 1) +
  labs(y = "Fixed effect", x = "China")

# tests
test.res = master %>%
  left_join(cntry.fe2 %>% dplyr::rename(fe2 = fe)) %>%
  left_join(cntry.fe3 %>% dplyr::rename(fe3 = fe))

projected<-test.res %>%
  mutate(log_desal2 = log_gdp*(c1l2) + gov*(c3l2) + log_wsi*(c4l2) + log_coast*(c5l2) + fe2,
         log_desal3 = log_gdp*(c1l3) + gov*(c3l3) + log_wsi*(c4l3) + fe3)

# plot
ggplot(projected %>% filter( iso3 %in% c('USA','ARE','SAU','ESP','KWT','QAT')) )+
  geom_line(aes(x = year,y = exp(log_desal) ), color = 'black')+
  geom_line(aes(x = year,y = exp(log_desal2) ), color = 'blue')+
  geom_line(aes(x = year,y = exp(log_desal3) ), color = 'red')+
  facet_wrap(~iso3)+theme_bw()

# check master, which variables are driving drop in projections for ARE, SAU, KWT
ggplot( )+
  geom_line(data = projected %>% filter( iso3 %in% c('ARE','SAU','KWT','QAT')),aes(x = year,y = log_desal2 ), color = 'grey',size = 2)+
  geom_line(data = master %>% filter( iso3 %in% c('ARE','SAU','KWT','QAT')),aes(x = year,y = log_desal ), color = 'black')+
  geom_line(data = master %>% filter( iso3 %in% c('ARE','SAU','KWT','QAT')),aes(x = year,y = log_gdp ), color = 'blue')+
  geom_line(data = master %>% filter( iso3 %in% c('ARE','SAU','KWT','QAT')),aes(x = year,y = log_wsi ), color = 'red')+
  geom_line(data = master %>% filter( iso3 %in% c('ARE','SAU','KWT','QAT')),aes(x = year,y = gov ), color = 'green')+
  facet_wrap(~iso3)+theme_bw()

ggplot(projected %>% filter( iso3 %in%  quantiles[quantiles$quant == 'q1_3',]$iso3 ,
                             !iso3 %in% c('USA','ARE','SAU','ESP','KWT','QAT') ) )+
  geom_line(aes(x = year,y = exp(log_desal) ), color = 'black')+
  geom_line(aes(x = year,y = exp(log_desal2) ), color = 'blue')+
  geom_line(aes(x = year,y = exp(log_desal3) ), color = 'red')+
  facet_wrap(~iso3)+theme_bw()

ggplot(projected %>% filter( iso3 %in%  quantiles[quantiles$quant == 'q2_3',]$iso3 ,
                             !iso3 %in% c('USA','ARE','SAU','ESP','KWT','QAT') ) )+
  geom_line(aes(x = year,y = exp(log_desal) ), color = 'black')+
  geom_line(aes(x = year,y = exp(log_desal2) ), color = 'blue')+
  geom_line(aes(x = year,y = exp(log_desal3) ), color = 'red')+
  facet_wrap(~iso3)+theme_bw()

ggplot(projected %>% filter( iso3 %in%  quantiles[quantiles$quant == 'q3_3',]$iso3 ) )+
  geom_line(aes(x = year,y = exp(log_desal) ), color = 'black')+
  geom_line(aes(x = year,y = exp(log_desal2) ), color = 'blue')+
  geom_line(aes(x = year,y = exp(log_desal3) ), color = 'red')+
  facet_wrap(~iso3)+theme_bw()

# lm2 and lm3 equal now
###########################
##### PROJECTIONS #########
###########################

#### TAKE MESSAGE REGION-BASIN structure ####
reg = 'R11' # or R12 or a ISO3
scen = 'SSP2'
if (!reg %in% master$iso3){
  print(paste0("ATTENTION ",reg," is not in the dataset, continue only if its is a non-country (e.g. R11)"))
}
basin_by_region.spdf = readOGR('P:/ene.model/NEST/delineation/data/delineated_basins_new',
                               paste0('basins_by_region_simpl_',reg), verbose=FALSE)
row.names(basin_by_region.spdf@data) = 1:length(basin_by_region.spdf$BASIN)

# Gadm country deineation
countries.spdf = readOGR('P:/ene.general/Water/global_basin_modeling/basin_delineation/data/country_delineation/gadm/output_data', 'gadm_country_boundaries', verbose=FALSE)
countries.spdf@data$ID = as.numeric(countrycode(countries.spdf@data$ISO, "iso3c", "iso3n"))
countries.spdf = countries.spdf[,c('ID','ISO','NAME','REGION','STATUS','CONTINENT')]

#read in raster from ED. ATTENTION 2100 and 2110 missing
## Set path data folder in message_ix working copy
msg_data = paste0('P:/ene.model/NEST')
data_path = path.expand(msg_data)
RCPs = c('no_climate','2p6','6p0')

nc = nc_open( paste0(data_path,'/water_scarcity/wsi_memean_ssp2_rcp6p0.nc'), verbose=FALSE)
watstress.brick = brick( paste0(data_path,'/water_scarcity/wsi_memean_ssp2_rcp6p0.nc') )

ras1 = watstress.brick$X2010s
plot(ras1)
start.spdf = rasterToPoints(ras1, spatial = TRUE)

writeOGR(
  start.spdf,
  'P:/ene.model/NEST/desalination',
  paste0('WSI_check'),
  driver="ESRI Shapefile",
  overwrite_layer=TRUE
)
start.spdf$X2010s = NULL

basin_info = over(start.spdf,basin_by_region.spdf)
country_info = over(start.spdf,countries.spdf)

for (rcp in RCPs) {
  print(paste0("RCP: ",rcp))
  if (rcp == '2p6'){
    nc = nc_open( paste0(data_path,'/water_scarcity/wsi_memean_ssp1_rcp4p5.nc'), verbose=FALSE)
    watstress.brick = brick( paste0(data_path,'/water_scarcity/wsi_memean_ssp1_rcp4p5.nc') )

  } else{
    nc = nc_open( paste0(data_path,'/water_scarcity/wsi_memean_ssp2_rcp6p0.nc'), verbose=FALSE)
    watstress.brick = brick( paste0(data_path,'/water_scarcity/wsi_memean_ssp2_rcp6p0.nc') )
  }

  ras1 = watstress.brick$X2010s
  plot(ras1)
  start.spdf = rasterToPoints(ras1, spatial = TRUE)
  start.spdf$X2010s = NULL
  initial_years <- seq(2010, 2090, 5)

  for (i in seq(1:nlayers(watstress.brick)) ){
    r <- raster(watstress.brick, layer=i)
    proj4string(r) = proj4string(watstress.brick)
    yr = as.numeric(gsub('X','',gsub('s','',names(r)) ))
    if (yr %in% initial_years){
      column_name = paste0('WSI.', yr )
      start.spdf@data[,column_name] = raster::extract(r,start.spdf)
      # there are 876 Na values, we set them = 0
      start.spdf@data[column_name][is.na(start.spdf@data[column_name])] = 0
    } else {}

  }

  data.spdf = start.spdf
  data.spdf@data = data.spdf@data %>%
    bind_cols(basin_info %>% select(BCU_name),
              country_info %>% select(ISO) %>% dplyr::rename(iso3 = ISO))

  map_years = rbind(data.frame(my = initial_years) %>% mutate(sy = my -2),
                    data.frame(my = initial_years) %>% mutate(sy = my -1),
                    data.frame(my = initial_years) %>% mutate(sy = my),
                    data.frame(my = initial_years) %>% mutate(sy = my +1),
                    data.frame(my = initial_years) %>% mutate(sy = my +2)) %>%
    arrange(my)

  # - makje a df with coordinates and years as columns
  data.df = cbind(data.spdf@coords, data.spdf@data) %>% select(BCU_name,iso3,everything()) %>%
    gather(key = year, value = wsi, 5:19) %>%
    mutate(year = as.numeric( gsub('WSI.','',year))) %>% drop_na()
  # - get national GDP, national governance indicator. point wsi and national coast values (as in regression)
  # - mask out points not in coast area
  # - project and make basin average

  # GDP
  gdp_proj<-read.csv("P:/ene.model/NEST/governance/governance_2021/input/navigate_ssp.csv") %>%
    filter(scenario=="SSP2", variable=="gdppc") %>%
    rename(iso3=region) %>%
    select(-c(scenario, variable)) %>%
    pivot_longer(!iso3, names_to = "Year", values_to = "gdp") %>%
    mutate(year = as.numeric(gsub('X','',Year))) %>%
    filter(year>=2020) %>%
    select(iso3,year,gdp)

  # make 5y averages
  gdp_proj = gdp_proj %>% filter(year <= 2092) %>% drop_na() %>%
    rename(sy = year) %>%
    left_join(map_years) %>% group_by(iso3,my) %>%
    summarise(gdp = mean(gdp)) %>% ungroup() %>%
    rename(year = my) %>%
    select(iso3, year, gdp)

  # Governance projections
  gov_proj<- read.csv("P:/ene.model/NEST/governance/governance_obs_project.csv") %>%
    mutate(gov=range01(governance)) %>%
    arrange(countrycode, year) %>%
    dplyr::rename(iso3 = countrycode) %>%
    filter(year >= 2018,year < 2092,
           scenario == scen) %>%
    select(iso3, year, gov)

  # make 5y averages
  gov_proj = gov_proj %>% filter(year <= 2092) %>% drop_na() %>%
    rename(sy = year) %>%
    left_join(map_years) %>% group_by(iso3,my) %>%
    summarise(gov = mean(gov)) %>% ungroup() %>%
    rename(year = my) %>%
    select(iso3, year, gov)

  # Governance from Elina
  read.csv("P:/ene.model/NEST/governance/governance_2021/output/projections_country_ssp2.csv")

  #values in lat historical period, LOG
  hist_cum_cap = master %>% select(iso3,year,log_desal) %>% group_by(iso3) %>%
    mutate(hist_cap = max(log_desal)) %>% ungroup() %>%
    select(iso3,hist_cap) %>% distinct()

  future_proj = data.df %>% left_join(gdp_proj) %>% left_join(gov_proj) %>%
    left_join(hist_cum_cap) %>% drop_na()

  if (rcp == 'no_climate'){
    future_proj = future_proj %>% group_by(iso3,x,y) %>%
    mutate(wsi = first(wsi)) %>% ungroup()
    }

  future_proj = future_proj %>% mutate(log_gdp = log(gdp),
                                       log_wsi = log(wsi)) %>%
    left_join(fe3 %>% ungroup() %>%
                select(iso3,year,fe_adj)) %>%
    mutate(log_desal3 = log_gdp*(c1l3) + gov*(c3l3) + log_wsi*(c4l3) + fe_adj) %>%
    filter(!is.infinite(log_wsi)) %>% drop_na(fe_adj)

  #scale based on last historical year
  future_plot = future_proj %>% group_by(iso3,year) %>%
    mutate(desal_cap = exp(log_desal3) ) %>% 
    summarise(desal_cap = mean(desal_cap)) %>%
    # adjust to hit_Cap
    group_by(iso3) %>% mutate(min_cap = min(desal_cap)) %>%
    left_join(hist_cum_cap) %>%
    # move to absolute values
    mutate(hist_cap = exp(hist_cap) ) %>% 
    # diff_hist is in ABSOLUTE value
    mutate(diff_hist =  hist_cap - min_cap,
           desal_cap = desal_cap + diff_hist) %>%
    ungroup()

  #apply diff_hist to all countries in the point database
  diff_hist = future_plot %>% select(iso3,diff_hist) %>% distinct()
  ## check if initial projected values is higher/equal to historical data

  future_proj_out= future_proj %>% left_join(diff_hist) %>%
    mutate(desal_cap = exp(log_desal3),
           desal_cap = desal_cap + diff_hist)

  ggplot( )+
    # geom_line(data = projected %>% filter( iso3 %in% c('ARE','USA','ESP','TKM','SAU','KWT','QAT')),aes(x = year,y = log_desal3 ), color = 'grey',size = 2)+
    geom_line(data = master %>% filter( iso3 %in% c('ARE','USA','ESP','TKM','SAU','KWT','QAT')),aes(x = year,y = exp(log_desal) ), color = 'black')+
    # geom_line(data = gdp_proj %>% filter( iso3 %in% c('ARE','USA','ESP','TKM','SAU','KWT','QAT')),aes(x = year,y = log(gdp) ), color = 'green')+
    geom_line(data = future_plot %>% filter( iso3 %in% c('ARE','USA','ESP','TKM','SAU','KWT','QAT')),aes(x = year,y = desal_cap ), color = 'red')+
    facet_wrap(~iso3)+theme_bw()+ggtitle('SECOND case, abs val')

  ggplot ()+
    # geom_line(data = projected %>% filter( iso3 %in%  quantiles[quantiles$quant == 'q1_3',]$iso3 ,
    #                                        !iso3 %in% c('USA','ARE','SAU','ESP','KWT','QAT','TKM') ),
    #           aes(x = year,y = exp(log_desal3) ), color = 'grey', size = 2)+
    geom_line(data = master %>% filter( iso3 %in%  quantiles[quantiles$quant == 'q1_3',]$iso3 ,
                                           !iso3 %in% c('USA','ARE','SAU','ESP','KWT','QAT','TKM') ),
              aes(x = year,y = exp(log_desal) ), color = 'black')+
    geom_line(data = future_plot %>% filter( iso3 %in%  quantiles[quantiles$quant == 'q1_3',]$iso3 ,
                                           !iso3 %in% c('USA','ARE','SAU','ESP','KWT','QAT','TKM') ),
              aes(x = year,y = desal_cap ), color = 'red')+
    facet_wrap(~iso3)+theme_bw()

  # TKM weird GDP trend
  # basin average without trimming out location far from coasts
  fut_proj_basin = future_proj_out %>% group_by(BCU_name, year) %>%
    summarise(cap_m3_day = mean(desal_cap)) %>% ungroup() %>%
    mutate(cap_km3_year = cap_m3_day *1e-9 * 365)

  assign(paste0('basin_desal_',rcp),fut_proj_basin)
}

# compare
comp = basin_desal_2p6 %>% mutate(rcp = '2p6') %>% bind_rows(
  basin_desal_6p0 %>% mutate(rcp = '6p0'),
  basin_desal_no_climate %>% mutate(rcp = 'no_climate')
)
# global capacity
comp_glob = comp %>% group_by(rcp,year) %>%
  summarise(cap_km3_year = sum(cap_km3_year)) %>% ungroup()

ggplot(comp_glob)+
  geom_line(aes(x = year,y = cap_km3_year, color = rcp),size = 1)+
  theme_bw()+
  ggtitle("Desalination potential projections, global, SSP2")+
  ylab("km3/year")+
  theme(axis.title.x = element_blank(),
        legend.position = 'bottom')

# Main basins
ggplot(comp %>% filter(BCU_name %in% c("120|MEA","66|SAS","33|NAM","4|WEU","158|AFR","7|AFR")) )+
  geom_line(aes(x = year,y = cap_km3_year, color = rcp),
            size = 1)+
  facet_wrap(~BCU_name)+theme_bw()+
  ggtitle("Desalination potential projections, basins, SSP2")+
  ylab("km3/year")+
  theme(axis.title.x = element_blank(),
        legend.position = 'bottom')

# set negative values to 0
comp = comp %>% 
  mutate(cap_km3_year = if_else(cap_km3_year < 0, 0, cap_km3_year))

# output
write.csv(comp %>% select(BCU_name,rcp,year,cap_km3_year),
          paste0('P:/ene.model/NEST/desalination/projected_desalination_potential_km3_year_',reg,'.csv'),
          row.names = F)


#### Historical capacity by basin ####
# to set existing capacity in historical time periods
hist_cap.df = read.csv('P:/ene.model/NEST/desalination/DESALCAPACITYDATA2016_current_online.csv') %>%
  mutate(tec_type = if_else(technology %in% c( "MSF (Multi-stage Flash)","MED (Multi-effect Distillation)",
                                               "MD (Membrane Distillation)","VC (Vapour Compression)","Other / Unknown"),
                            'distillation','membrane')) %>%
  rename(year = online) %>%
  group_by(lat,lon,year,tec_type) %>%
  summarise(cap_km3_year = sum(m3_per_day) * 1e-9*365) %>% ungroup() %>%
  drop_na()

map_hist_years = rbind(data.frame(my = seq(1995,2015,5)) %>% mutate(sy = my -2),
                  data.frame(my = seq(1995,2015,5)) %>% mutate(sy = my -1),
                  data.frame(my = seq(1995,2015,5)) %>% mutate(sy = my),
                  data.frame(my = seq(1995,2015,5)) %>% mutate(sy = my +1),
                  data.frame(my = seq(1995,2015,5)) %>% mutate(sy = my +2)) %>%
  arrange(my)

hist_cap.df = hist_cap.df %>% left_join(map_hist_years %>% rename(year = sy)) %>%
  mutate(my = if_else(is.na(my) & year < 1995, 1995,
                      if_else(is.na(my) & year > 2015,2015,my))) %>%
  filter(!year > 2020, !year < 1990) %>%
  group_by(lat,lon,my,tec_type) %>%
  summarise(cap_km3_year = sum(cap_km3_year) ) %>% ungroup() %>%
  rename(year = my)

hist_cap.spdf = hist_cap.df
coordinates(hist_cap.spdf) = ~ lon + lat
proj4string( hist_cap.spdf) = crs(basin_by_region.spdf)
basin_info_desal = over(hist_cap.spdf,basin_by_region.spdf)

hist_cap.out = hist_cap.df %>% bind_cols(basin_info_desal) %>%
  group_by(BCU_name,year,tec_type) %>%
  summarise(cap_km3_year = sum(cap_km3_year)) %>% ungroup() %>%
  #there are soem NA
  drop_na()

#technical lifetime of desal tech = 30 y

# compare historical with first year of projections
hist_comp = hist_cap.out %>% ungroup() %>% group_by(BCU_name, year) %>% 
  summarise(hist_cap = sum(cap_km3_year)) %>% 
  summarise(year = year,
            hist_cap = hist_cap,
            hist_cap_cum = cumsum(hist_cap)) %>% ungroup() %>% 
  left_join(comp %>% select(BCU_name,rcp,year,cap_km3_year) %>% 
  filter(year == 2020) %>% select(-year) ) %>% 
  # any cases of hist 2015 higher than 2020
  mutate(diff2020 = cap_km3_year - hist_cap_cum)

# for cases of mismatch, cum 2015 and projections
high2020 = hist_comp %>% filter(year == 2015, diff2020 < 0) %>% 
  mutate(Xhist = hist_cap_cum/ cap_km3_year,
         fianl_hist_cum = hist_cap_cum / (Xhist * 1.05)) %>% 
  filter(rcp == 'no_climate') %>% 
  select(BCU_name, Xhist)

# adjust hist cap
hist_cap.out = hist_cap.out %>% left_join(high2020) %>% 
  mutate(cap_km3_year = if_else(!is.na(Xhist),cap_km3_year / (Xhist * 1.05),cap_km3_year )) %>% 
  select(-Xhist)

write.csv(hist_cap.out,
          paste0('P:/ene.model/NEST/desalination/historical_capacity_desalination_km3_year_',reg,'.csv'),
          row.names = F)

# for countries with no desalination"))
hist_cap.out2 = data.frame(BCU_name = basin_by_region.spdf$BCU_name) %>% 
  crossing(year = c(2010,2015)) %>% 
  crossing(tec_type = c("membrane","distillation")) %>% 
  mutate(cap_km3_year = 0)

write.csv(hist_cap.out,
          paste0('P:/ene.model/NEST/desalination/historical_capacity_desalination_km3_year_',reg,'.csv'),
          row.names = F)

# projection
comp2 = data.frame(BCU_name = basin_by_region.spdf$BCU_name) %>% 
  crossing(rcp = RCPs) %>% 
  crossing(year = seq(2020, 2090, 5)) %>% 
  mutate(cap_km3_year = 0.001)

write.csv(comp2 %>% select(BCU_name,rcp,year,cap_km3_year),
          paste0('P:/ene.model/NEST/desalination/projected_desalination_potential_km3_year_',reg,'.csv'),
          row.names = F)

#!/bin/sh

# Settings for bash

# Exit immediately on any error
set -e
# Echo commands for debugging
set -x

# Source package name in Git URLs and file paths
SRC=message_data
# Python name
S_PACKAGE=$SRC
# Remote for its repo
SRC_REPO=git@github.com:iiasa/$SRC.git
# Specific branch from which to migrate code
SRC_BRANCH=nexus_move

# Destination package name in Git URLs and file paths
DST=message-ix-models
# Python name
D_PACKAGE=message_ix_models
# Remote for its repo
DST_REPO=git@github.com:iiasa/$DST.git
# Branch to create in the destination. This is created
# from the HEAD of the default branch, e.g. "main".
BRANCH=migrate-nexus

# Path fragment for path renaming and filtering.
# Edit this together with 2-migrate.sh.
MOD=water

#!/bin/sh
#
# Migrate a module from message_data to message_ix_models,
# preserving its git history.

. settings.sh

# Echo a message on how to restart
echo "To undo, run:"
echo "  $ rm -rf $DST && git clone $DST_REPO"

# Clone the destination repository
git clone $DST_REPO $DST

# Change directory to the clone
cd $DST

# commented: current process uses a manual rebase after this script
#
# # Store the initial commit of the destination repo
# DST_BASE_COMMIT=$(git rev-list --max-parents=0 HEAD)
# [ -n "$DST_BASE_COMMIT" ] || exit 1
#
# echo "Will rebase initial commits on to:"
# git show --no-patch $DST_BASE_COMMIT

# Add the *source* repo as a remote to the *destination* repo;
# also fetch
git remote add --fetch $SRC ../$SRC

# Copy LFS objects from source repo's .git directory.
#
# This ensures that when commit history is being rewritten in the current
# directory, references to LFS objects are resolved, because they are in the
# local cache. The script 1-prep.sh must have been run to populate the cache.
cp -r ../$SRC/.git/lfs/objects/* .git/lfs/objects/

# Check out the *source* branch as a new branch in the *destination* repo
git checkout -b $BRANCH $SRC/$SRC_BRANCH

# Use git-filter-repo
# --refs $BRANCH = only filter the source branch.
#
# --path-rename = rename several paths and files under them, i.e.:
# - Module data.
# - Module code. The "/model/" path fragment could also be "/project/", or
#   removed entirely.
# - Module tests.
#
# Add or remove lines here as necessary; not all modules have all the above
# pieces, and some modules have additional pieces.
git filter-repo \
  --refs $BRANCH --force --debug \
  --path-rename data/$MOD/:$D_PACKAGE/data/$MOD/ \
  --path-rename $S_PACKAGE/model/$MOD/:$D_PACKAGE/model/$MOD/ \
  --path-rename $S_PACKAGE/tests/model/$MOD/:$D_PACKAGE/tests/model/$MOD/

# --path = keep only a subset of files and directories.
#
# This has the effect of discarding the top-level message_data and data
# directories, keeping only message_ix_models. This operates on the paths
# renamed by the previous command. It would be possible to combine in a single
# command, but we would then need to specify the *original* paths to keep.
#
# NB can add lines to keep other files, e.g.:
# --path doc/$MOD/
git filter-repo \
  --refs $BRANCH --force --debug \
  --message-callback 'return re.sub(b"^[a-z]", message[:1].upper(), message)' \
  --path $D_PACKAGE/

# commented: unused
#
# # --invert-paths = *remove* some specific files e.g. non-reporting test data
# git filter-repo \
#  --refs $BRANCH --force --debug \
#  --invert-paths \
#  --path-regex "^$DST/tests/data/[^r].*$"

# commented: current process uses a manual rebase after this script. This method
# can fail if the commit history is non-linear, with conflicts.
#
# # Store the initial commit(s) of the source branch, after filtering.
# # If the history is not linear, there may be more than one.
# SRC_BASE_COMMIT=$(git rev-list --max-parents=0 $BRANCH)
# [ -n "$SRC_BASE_COMMIT" ] || exit 1
#
# # Graft the initial commit(s) of the source branch onto the first commit of the
# # destination repo, so the two share a common initial commit.
# #
# # If there are more than one, the git-replace operations must be done together
# # and filter-repo last.
# for SBC in $SRC_BASE_COMMIT;
# do
#   git replace --graft $SBC $DST_BASE_COMMIT
# done
#
# git filter-repo --refs $BRANCH --force --debug

# Generate a TODO list for "git rebase --interactive --empty=drop main"
git log --oneline | tac | sed -E "s/^/p /" >../rebase-todo.txt

# Generate a list to help identifying duplicate commits
git log --oneline | cut -d" " -f2- | sort | uniq -d >../duplicates.txt

# After this, see the instructions in doc/migrate.rst

#!/bin/sh
#
# Prepare to migrate code

. settings.sh

# Clone the source repo
git clone -b $SRC_BRANCH $SRC_REPO $SRC

# Change directory to the clone
cd $SRC

# Fetch all LFS objects existing on the server; about 5.7 GB for message_data
git lfs fetch --all

# Make a list of missing LFS objects; possibly empty
#
# Per https://github.com/git-lfs/git-lfs/issues/4232#issuecomment-689967255
git lfs ls-files --all -l | \
  perl -n -e 'chomp; @x = split; next if $x[1] eq "*"; $o = $x[0]; $p = substr($o, 0, 2) . "/" . substr($o, 2, 2) . "/$o"; print "$o\n" unless -f ".git/lfs/objects/$p";' \
  >lfs-sha256s-to-remove.txt

<!--

Delete each of these instruction comments as you complete it.

Title: use a short, declarative statement similar to a commit message,
e.g. “Change [thing X] to [fix solve bug|enable feature Y]”

-->

**Required:** write a single sentence that describes the changes made by this PR.

<!-- Optional: write a longer description to help a reviewer understand the PR in ~3 minutes. -->

## How to review

**Required:** describe specific things that reviewer(s) must do, in order to ensure that the PR achieves its goal.
If no review is required, write “No review:” and describe why.

<!--
For example, one or more of:

- Read the diff and note that the CI checks all pass.
- Run a specific code snippet or command and check the output.
- Build the documentation and look at a certain page.
- Ensure that changes/additions are self-documenting, i.e. that another
  developer (someone like the reviewer) will be able to understand what the code
  does in the future.
-->

## PR checklist

<!-- This item is always required. -->
- [ ] Continuous integration checks all ✅
  <!--
  The following items are all *required* if the PR results in changes to user-
  facing behaviour, e.g. new features or fixes to existing behaviour. They are
  *optional* if the changes are solely to documentation, CI configuration, etc.

  In ambiguous cases, strike them out and add a short explanation, e.g.

  - ~Add or expand tests.~ No change in behaviour, simply refactoring.
  -->
- [ ] Add or expand tests; coverage checks both ✅
- [ ] Add, expand, or update documentation.
- [ ] Update doc/whatsnew.
  <!--
  To do this, add a single line at the TOP of the “Next release” section of
  doc/whatsnew.rst, where '999' is the GitHub pull request number:

  - Title or single-sentence description from above (:pull:`999`:).

  Commit with a message like “Add #999 to doc/whatsnew”
  -->
